<?php

$return['admin']['main'] = array(
    'navigation' => array(
        'label' => 'nav-cms_navigation',
        'resource' => 'navigation_admin_index',
        'route' => 'navigation_admin',
        'icon' => 'move'
    ),

    'content' => array(
        'label' => 'nav-cms_content',
        'route' => 'text-page_admin',
        'icon' => 'pencil',
        'pages' => array(
            array(
                'label' => 'nav-cms_text-page',
                'resource' => 'text-page_admin_index',
                'route' => 'text-page_admin',
                'icon' => 'pencil'
            ),
            array(
                'label' => 'nav-cms_page_admin',
                'resource' => 'page_admin_index',
                'route' => 'page_admin',
                'icon' => 'file'
            ),
        ),
    ),

    'files' => array(
        'label' => 'nav-cms_filemanager',
        'resource' => 'filemanager',
        'route' => 'filemanager',
        'icon' => 'paperclip'
    ),

    'label' => array(
        'label' => 'nav-cms_label',
        'route' => 'admin_label',
        'resource' => 'admin_label_index',
        'icon' => 'map-marker'
    ),

    'users' => array(
        'label' => 'nav-cms_users',
        'resource' => 'user_admin_index',
        'uri' => '#',
        'icon' => 'user',
        'pages' => array(
            array(
                'label' => 'nav-cms_user-admin_list',
                'resource' => 'user_admin_index',
                'route' => 'user_admin',
                'icon' => 'user',
            ),
            array(
                'label' => 'nav-cms_auth-acl',
                'resource' => 'auth_acl',
                'route' => 'auth_acl',
                'icon' => 'lock',
            )
        )
    ),

    'modules' => array(
        'label' => 'nav-cms_modules',
        'uri' => '#',
        'icon' => 'cog',
        'pages' => array(
        )
    )
);



// RIGHT NAVIGATION CMS MENU

$langs_navigation = array();
$availableLanguages = Base_I18n::getAvailableLanguages();
if(count($availableLanguages) > 0){
    $langs_navigation[] = array(
        'label' => 'nav-cms-header_language-cms',
        'uri' => '',
        'class' => 'dropdown-header',
    );

    foreach($availableLanguages as $k => $v){
        $langs_navigation[] = array(
            'label' => $v['name'],
            'label_pre' => '<img src="/assets/img/flags/'.$k.'.gif" /> ',
            'uri' => '/'.$k.'/admin',
        );
    }
    $langs_navigation[] = array(
        'uri' => '',
        'class' => 'divider',
    );
    $langs_navigation[] = array(
        'label' => 'nav-cms-header_language-content',
        'uri' => '',
        'class' => 'dropdown-header',
    );

    foreach($availableLanguages as $k => $v){
        $langs_navigation[] = array(
            'label' => $v['name'],
            'label_pre' => '<img src="/assets/img/flags/'.$k.'.gif" /> ',
            'uri' => Base::url().'?setContentLanguage='.$k,
        );
    }

    $langs_navigation[] = array(
        'uri' => '',
        'class' => 'divider',
    );

    $langs_navigation[] = array(
        'label' => 'nav-cms_language',
        'icon' => 'flag',
        'route' => 'admin_language',
        'resource' => 'admin_language'
    );
}


$return['admin']['main-right'] = array(
    'lang' => array(
        'label' => '',
        'label_pre' => '<img src="/assets/img/flags/' . Base_I18n::getLangCode() . '.gif" /> ',
        'uri' => '#',
        'icon' => 'flag',
        'icon_class' => 'icon-white',
        'pages' => $langs_navigation,
    ),

    'settings' => array(
        'label' => '',
        'uri' => '#',
        'icon' => 'wrench',
        'icon_class' => 'icon-white',
        'pages' => array(
            array(
                'label' => 'nav-cms_setting_clear-cache',
                'route' => 'admin_setting_clear-cache',
                'icon' => 'refresh',
                'resource' => 'admin_setting_clear-cache',
            )
        )
    ),

    'account' => array(
        'label' => 'nav-cms_logout',
        'route' => 'logout',
        'icon' => 'log-out'
    )
);



return $return;