<?php

class IndexController extends Zend_Controller_Action
{

	public function indexAction() {
		throw new Exception("Router not found", 404);
	}


    public function sitemapAction()
    {
        $this->getResponse()->setHeader('Content-type', 'application/xml');
        $modules = Base_Module::getModules();
        $frontController = Zend_Controller_Front::getInstance();
        Base_Layout::disableLayout();
        Base_Layout::disableView();

        $cache = Base_Cache::getCache('default');
        $cache_name = 'sitemap';
        $sitemap = $cache->load($cache_name);

        if( $sitemap === false ){
            $sitemap_data = array();
            $sitemap_data[] = array('loc' => PROTOCOL.'://'.DOMAIN.'/');

            foreach($modules as $module){
                $classPath = $frontController->getModuleDirectory($module).DS.'library'.DS.'Sitemap.php';
                if (Zend_Loader::isReadable($classPath)) {
                    $class_name = Base::dashToCamel($module).'_Sitemap';

                    $class = new $class_name();

                    $sitemap_data = array_merge($sitemap_data, $class->getData());
                }
            }

            $this->view->sitemap_data = $sitemap_data;
            $sitemap = $this->view->render('index/sitemap.phtml');

            $cache->save( $sitemap, $cache_name );
        }


        echo $sitemap;
    }


    public function robotsTxtAction()
    {
        Base_Layout::disableLayout();
        Base_Layout::disableView();
        $this->getResponse()->setHeader('Content-type', 'text/plain');

        echo Setting::getSetting('system.robots');
    }

}
