CREATE TABLE `news` (
  `id_news` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id_news_image` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id_news`),
  KEY `id_news_image` (`id_news_image`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

ALTER TABLE  `news` CHANGE  `id_news_image`  `id_news_image` INT( 10 ) UNSIGNED NULL DEFAULT NULL;

ALTER TABLE  `news` ADD FOREIGN KEY (  `id_news_image` ) REFERENCES `image` (
  `id_image`
) ON DELETE SET NULL ON UPDATE RESTRICT ;

ALTER TABLE  `news` ADD  `id_news_category` INT( 10 ) UNSIGNED NOT NULL AFTER  `id_news` ,
ADD INDEX (  `id_news_category` );

CREATE TABLE `news_translation` (
  `id_news` int(10) unsigned NOT NULL,
  `id_language` tinyint(3) unsigned NOT NULL,
  `title` varchar(255) NOT NULL,
  `lead` text NOT NULL,
  `text` text NOT NULL,
  PRIMARY KEY (`id_news`,`id_language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE  `news_translation` ADD INDEX (  `id_language` );

ALTER TABLE  `news_translation` ADD FOREIGN KEY (  `id_news` ) REFERENCES `news` (
  `id_news`
) ON DELETE CASCADE ON UPDATE RESTRICT ;

ALTER TABLE  `news_translation` ADD FOREIGN KEY (  `id_language` ) REFERENCES `language` (
  `id_language`
) ON DELETE CASCADE ON UPDATE RESTRICT ;

CREATE TABLE `news_category` (
  `id_news_category` int(10) unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id_news_category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE `news_category_translation` (
  `id_news_category` int(10) unsigned NOT NULL,
  `id_language` tinyint(3) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id_news_category`,`id_language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE  `news_category_translation` ADD INDEX (  `id_language` );

ALTER TABLE  `news_category_translation` ADD FOREIGN KEY (  `id_news_category` ) REFERENCES `news_category` (
  `id_news_category`
) ON DELETE CASCADE ON UPDATE RESTRICT ;

ALTER TABLE  `news_category_translation` ADD FOREIGN KEY (  `id_language` ) REFERENCES `language` (
  `id_language`
) ON DELETE CASCADE ON UPDATE RESTRICT ;