<?php

/**
 * EmailSend
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 * 
 * @package    ##PACKAGE##
 * @subpackage ##SUBPACKAGE##
 * @author     ##NAME## <##EMAIL##>
 * @version    SVN: $Id: Builder.php 7490 2010-03-29 19:53:27Z jwage $
 */
class EmailSend extends Table_EmailSend
{
    private $_mail = null;

    public static function getQuery($options = array())
    {
        $query = parent::getQuery($options);

        $query->addOrderBy('o.created_at DESC');

        if ( isset( $options['from'] ) && strlen( $options['from'] ) > 0 ) {
            $query->addWhere('o.from LIKE ?', '%' . $options['from'] . '%');
        }

        if ( isset( $options['to'] ) && strlen( $options['to'] ) > 0 ) {
            $query->addWhere('o.to LIKE ?', '%' . $options['to'] . '%');
        }

        if ( isset( $options['is_sent'] ) && strlen( $options['is_sent'] ) > 0 ) {
            $query->addWhere('o.is_sent = ?', $options['is_sent']);
        }

        if ( isset( $options['to_send'] ) && strlen( $options['to_send'] ) > 0 ) {
            $query->addWhere('o.to_send = ?', $options['to_send']);
        }

        if ( isset( $options['exception'] ) && strlen( $options['exception'] ) > 0 ) {
            if($options['exception'])
            {
                $query->addWhere('o.exception != ?', '');
            }
            else
            {
                $query->addWhere('o.exception = ?', '');
            }
        }

        if ( isset( $options['created_at_from'] ) && !empty( $options['created_at_from'] ) ) {
            if ( $options['created_at_from'] < @$options['created_at_to']) $query->addWhere('o.created_at >= ?', $options['created_at_from']);
        }

        if ( isset( $options['created_at_to'] ) && !empty( $options['created_at_to'] ) ) {
            if ( @$options['created_at_from'] < $options['created_at_to']) $query->addWhere('o.created_at <= ?', $options['created_at_to']);
        }

        if ( isset( $options['sent_time_from'] ) && !empty( $options['sent_time_from'] ) ) {
            if ( $options['sent_time_from'] < @$options['sent_time_to']) $query->addWhere('o.sent_time >= ?', $options['sent_time_from']);
        }

        if ( isset( $options['sent_time_to'] ) && !empty( $options['sent_time_to'] ) ) {
            if ( @$options['sent_time_from'] < $options['sent_time_to']) $query->addWhere('o.sent_time <= ?', $options['sent_time_to']);
        }

        return $query;
    }

    public function getBaseMail()
    {
        if($this->_mail === null)
        {
            $this->_mail = @unserialize($this->getMail());
        }
        return $this->_mail;
    }

    public function getCc()
    {
        $baseMail = $this->getBaseMail();
        $array = array();

        if($baseMail)
        {
            if(array_key_exists("Cc", $baseMail->getHeaders()))
            {
                $headers = $baseMail->getHeaders();
                foreach($headers['Cc'] as $key => $value)
                {
                    if($key === 'append') continue;
                    $array[] = $value;
                }
            }
        }

        return $array;
    }

    public function getBcc()
    {
        $baseMail = $this->getBaseMail();
        $array = array();

        if($baseMail) {
            if (array_key_exists("Bcc", $baseMail->getHeaders()))
            {
                $headers = $baseMail->getHeaders();
                foreach ($headers['Bcc'] as $key => $value)
                {
                    if ($key === 'append') continue;
                    $array[] = $value;
                }
            }
        }
        return $array;
    }

    public function getHtml()
    {
        $baseMail = $this->getBaseMail();

        if($baseMail)
        {
            return $baseMail->getBodyHtml()->getRawContent();
        }
        return '';
    }

    public function getText()
    {
        $baseMail = $this->getBaseMail();

        if($baseMail)
        {
            return $baseMail->getBodyText()->getRawContent();
        }
        return '';
    }

}