<?php

/**
 * Label
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 * 
 * @package    ##PACKAGE##
 * @subpackage ##SUBPACKAGE##
 * @author     ##NAME## <##EMAIL##>
 * @version    SVN: $Id: Builder.php 7490 2010-03-29 19:53:27Z jwage $
 */
class Label extends Table_Label
{

    const TYPE_LABEL = 'label';

    const TYPE_ROUTE = 'route';


    public static function getQuery($options = array())
    {
        $query = parent::getQuery($options);

        if ( @strlen( $options['type'] ) > 0 ) {
            $query->addWhere('o.type = ?', $options['type']);
        }

        if ( isset( $options['label'] ) && !empty( $options['label'] ) ) {
            $query->addWhere('o.label LIKE ?', '%' . $options['label'] . '%');
        }

        if ( isset( $options['value'] ) && !empty( $options['value'] ) ) {
            $query->addWhere('t.value LIKE ?', '%' . $options['value'] . '%');
        }

        if ( isset( $options['module'] ) && is_array( $options['module']) && !empty($options['module'])) {
            if(in_array('empty', $options['module'])){
                unset($options['module'][array_search('empty', $options['module'])]);
                $query->andWhere('o.module = ""');
                $query->orWhereIn('o.module', $options['module']);
            } else {
                $query->andWhereIn('o.module', $options['module']);
            }
        }

        if ( isset( $options['date_from'] ) && !empty( $options['date_from'] ) ) {
            if ( $options['date_from'] < @$options['date_to']) $query->addWhere('o.modified_at >= ?', $options['date_from']);
        }

        if ( isset( $options['date_to'] ) && !empty( $options['date_to'] ) ) {
            if ( @$options['date_from'] < $options['date_to']) $query->addWhere('o.modified_at <= ?', $options['date_to']);
        }

        return $query;
    }

    /**
     * @return array
     */
    public static function getTypes()
    {
        return array(self::TYPE_LABEL => self::TYPE_LABEL, self::TYPE_ROUTE =>self::TYPE_ROUTE);
    }

    /**
     * @param $id_language integer
     * @param $type string
     * @return array
     */
    public static function getLabels($id_language, $type = 'label')
    {
        $cache = Base_Cache::getCache();
        $cache_name = 'label_'.$id_language.'_'.$type;
        $labels = $cache->load($cache_name);

        if(false == $labels){
            $result = Doctrine_Query::create()
                ->select('l.id_label, l.label, t.value as value')
                ->from(__CLASS__.' l INDEXBY l.id_label')
                ->innerJoin('l.Translations t')
                ->addWhere('t.id_language = ?', $id_language)
                ->addWhere('l.type = ?', $type)
                ->execute(array(), Doctrine::HYDRATE_ARRAY);

            foreach($result as $v){
                $labels[$v['label']] = $v['value'];
            }

            $cache->save($labels, $cache_name);
        }

        return $labels;
    }

    /**
     * Add modification date before save
     * @param $event
     */
    public function preSave($event)
    {
        parent::preSave($event);
        $this->modified_at = date('YmdHis');
    }

    /**
     * Clean cache when add or modification label
     * @param $event
     */
    public function postSave($event)
    {
        parent::postSave($event);
        Base_Cache::clean();
    }
}