<?php

/**
 * Log
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 * 
 * @package    ##PACKAGE##
 * @subpackage ##SUBPACKAGE##
 * @author     ##NAME## <##EMAIL##>
 * @version    SVN: $Id: Builder.php 7490 2010-03-29 19:53:27Z jwage $
 */
class Log extends Table_Log
{
    const TYPE_CREATE       = 'create';
    const TYPE_DELETE       = 'delete';
    const TYPE_MODIFIED     = 'modified';
    const TYPE_LOGIN        = 'login';
    const TYPE_LOGOUT       = 'logout';

    /**
     * @var array list of types logs
     */
    private static $_typeList = array(
        self::TYPE_CREATE,
        self::TYPE_DELETE,
        self::TYPE_MODIFIED,
        self::TYPE_LOGIN,
        self::TYPE_LOGOUT,
    );

    public static function getQuery($options = array())
    {
        $query = parent::getQuery($options);
        $query->leftJoin('o.Relations r');

        $query->addSelect('CONCAT(u.name, " ", u.surname) as user_name')
            ->leftJoin('o.User u');

        if(isset($options['id_user']) && strlen($options['id_user']) > 0){
            $query->addWhere('o.id_user = ?', $options['id_user']);
        }

        if(
            isset($options['id_object']) && strlen($options['id_object']) > 0 &&
            isset($options['model']) && strlen($options['model']) > 0
        ){
            $query->addWhere('(o.id_object = ? AND o.model = ?) OR (r.id_object = ? AND r.model = ?)', array(
                $options['id_object'], $options['model'], $options['id_object'], $options['model']
            ));
        }else{
            if(isset($options['id_object']) && strlen($options['id_object']) > 0){
                $query->addWhere('(o.id_object = ? OR r.id_object = ?) ', array(
                    $options['id_object'], $options['id_object']
                ));
            }

            if(isset($options['model']) && strlen($options['model']) > 0){
                $query->addWhere('(o.model = ? OR r.model = ?)', array(
                    $options['model'], $options['model']
                ));
            }
        }

        if(isset($options['type']) && strlen($options['type']) > 0){
            $query->addWhere('o.type = ?', $options['type']);
        }

        if ( isset( $options['created_at_from'] ) && !empty( $options['created_at_from'] ) ) {
            $query->addWhere('o.created_at >= ?', $options['created_at_from']);
        }

        if ( isset( $options['created_at_to'] ) && !empty( $options['created_at_to'] ) ) {
            $query->addWhere('o.created_at <= ?', $options['created_at_to']);
        }

        return $query;
    }

    /**
     * @param $type
     * @param array $data
     * @param array $options
     * @return Log
     * @throws Exception
     */
    public static function addLog($type, $data = array(), $options = array())
    {
        if(!in_array($type, self::$_typeList)){
            throw new Exception('Wrong type of log in ' . __METHOD__);
        }

        $model = isset($options['model']) ? $options['model'] : get_called_class();
        $id_user = isset($options['id_user']) ? $options['id_user'] : Base_Auth::getUser('id_user');
        $id_object = isset($options['id_object']) ? $options['id_object'] : null;

        $log = new Log();
        $log->model = $model;
        $log->type = $type;
        $log->id_user = $id_user;
        $log->id_object = $id_object;
        $log->data = json_encode($data);

        if(isset($options['relations']) && !empty($options['relations'])){
            foreach($options['relations'] as $v){
                $logRelation = new LogRelation();
                $logRelation->id_object = $v['id_object'];
                $logRelation->model = $v['model'];

                $log->Relations->add($logRelation);
            }

        }

        $log->save();

        return $log;
    }

    public static function getLogToSendNotification()
    {
        /**
         * $arrayIn - Modele które należy dołączyć do logów
         */
        $arrayIn = array(Project::CLASS_NAME);

        $select = "
            IFNULL(o.notification_at, TRUE) as to_send,
            o.*, u.name as first_name, u.surname as last_name
        ";

        $query = Doctrine_Query::create()
            ->addSelect($select)
            ->from('Log o')
            ->innerJoin('o.User u')
            ->whereIn('o.model', $arrayIn)
            ->addWhere('u.archived_at IS NULL')
            ->having('to_send = 1');
        ;

        $result = $query->execute(array(), Doctrine::HYDRATE_ARRAY);

        return $result;
    }
}