<?php
/**
 * Created by PhpStorm.
 * User: Dawid Przygodzki
 * Date: 2015-01-13
 * Time: 12:55
 */

class Admin_EmailSendController extends Base_Controller_Action_Cms
{
    /**
     * @var EmailSend
     */
    private $_model;

    /**
     * @var Base_Mail
     */
    private $_mail;

    protected $_modelMassName = 'EmailSend';

    protected $_massActionMode = 'off';

    protected $_massActionModeType = array('on','off');

    public function indexAction()
    {
        $emailSendFilter = new Admin_Form_Filter_EmailSend();
        $data = $emailSendFilter->getValues($emailSendFilter->getElementsBelongTo());
        $this->_model = EmailSend::getQuery($data);

        $this->_modelMassActions = array(
            'send' => $this->view->translate('label_mass-action_send'),
            'delete' => $this->view->translate('label_mass-action_delete')
        );

        $this->view->formFilter = $emailSendFilter;
        $this->view->emailSendList = $this->_helper->paging($this->_model, array('limit' => 30, 'mode' => Doctrine::HYDRATE_RECORD));
        $this->view->actionMode = $this->_massActionMode;
        $this->view->modelMassActions = $this->_modelMassActions;
    }

    public function showAction()
    {
        $this->_model = EmailSend::findRecordAll($this->getParam('id_email_send'));
        $this->forward404Unless($this->_model);

        $this->view->emailSend = $this->_model;
    }

    public function showHtmlAction()
    {
        $this->_model = EmailSend::findRecordAll($this->getParam('id_email_send'));
        $this->forward404Unless($this->_model);

        $html = $this->view->translate('label_cms_email-send_empty_html_view');
        if($this->_model->getHtml() && strlen($this->_model->getHtml()) > 0)
        {
            $html = $this->_model->getHtml();
        }

        $this->view->layout()->disableLayout();
        $this->view->html = $html;
    }

    public function sendAction()
    {
        $this->_model = EmailSend::findRecordAll($this->getParam('id_email_send'));
        $this->forward404Unless($this->_model);

        $this->_send();

        $this->_redirector()->gotoRouteAndExit(array(), 'admin_email_send_index');
    }

    public function deleteAction()
    {
        $this->_model = EmailSend::findRecordAll($this->getParam('id_email_send'));
        $this->forward404Unless($this->_model);

        $this->_model->delete();

        $this->_flash()->success->addMessage('label_cms_delete_success');
        $this->_redirector()->gotoRouteAndExit(array(), 'admin_email_send_index');
    }

    public function sendMassAction($records = null, $params = null)
    {
        foreach($records as $key => $value)
        {
            $this->_model = EmailSend::findRecordAll($key);
            $this->forward404Unless($this->_model);

            if(!$this->_model->is_sent)
            {
                $this->_send(true);
            }

        }
    }

    private function _send($mass = false)
    {
        $this->_mail = @unserialize($this->_model['mail']);

        if($this->_mail instanceof Base_Mail && !$this->_model->is_sent)
        {
            $this->_mail->send(true, array('model' => $this->_model));
            if(!$mass) $this->_flash()->success->addMessage('label_cms_email-send_send_success');
        }
        else
        {
            if(!$mass) $this->_flash()->warning->addMessage('label_cms_email-send_send_error');
        }
    }
} 