<?php

class Admin_IndexController extends Base_Controller_Action_Cms
{
    /**
     * @var $_userDashboardModel UserDashboard
     */
    private $_userDashboardModel = null;

	public function indexAction()
    {
        $this->_userDashboardModel = UserDashboard::preparedModel();

        $layout = $this->_userDashboardModel->getLayoutName();
        $placeholders = $this->_userDashboardModel->getDataMapPlaceholders();

        foreach($placeholders as $name => $values){
            if(isset($values['widgets']) && count($values['widgets']) > 0)
            {
                foreach($values['widgets'] as $widget){
                    if(class_exists($widget['_class'])){
                        $widgetClass = new $widget['_class'];
                        unset($widget['_class']);
                        $this->view->placeholder($name)->append($widgetClass->render($widget));
                    } else {
                        throw new Exception('Widget ' . $widget['_class'] . ' does not exist.');
                    }
                }
            }
        }

        $buttonEditDashboard = '';
        if(!Setting::getSetting('edit_dashboard_on')){
            $buttonEditDashboard =
                '<a class="btn btn-success pull-right" style="margin-top: 3px;" href="'. Base::url('user_admin_dashboard_edit') .'">' .
                '<i class="glyphicon glyphicon-pencil"></i> ' .
                $this->view->translate('label_button_admin_index_edit_dashboard') . '</a>'
            ;
        }

        $this->_helper->viewRenderer($layout);
        $this->view->placeholder('page-title')->set($this->view->translate('cms-page-title_dashboard') . $buttonEditDashboard);
    }

    public function cmsShereElementsAction()
    {
        Base_Layout::setLayout('Admin', 'layout_empty');
        $file_config_name = 'cms_shere_points.php';
        $modules = Base_Module::getModules();
        $cmsShereElements = array();

        foreach($modules as $module_name => $data)
        {
            $filename = Base_Module::getModulePath($module_name) . DS . 'config' . DS . $file_config_name;
            if (file_exists($filename))
            {
                $content = include $filename;

                if (!empty($content[$module_name])) {
                    $cmsShereElements[$module_name] = $content[$module_name];
                }
            }
        }

        $this->view->cmsShereElements = $cmsShereElements;
    }
}
