<?php
/**
 * Created by PhpStorm.
 * User: Dawid Przygodzki
 * Date: 2015-01-14
 * Time: 10:36
 */

class Admin_Form_Filter_EmailSend extends Base_Form_Vertical {

    /**
     * @var bool
     */
    protected $_filter = true;

    public function init()
    {
        $this->setMethod('get');
        $this->setAction('?page=1');
        $fields = array();

        $fields['from'] = $this->createElement('text', 'from', array(
            'label' => $this->_tlabel.'from',
            'dimension' => 12,
            'filters' => array('StringTrim'),
        ));

        $fields['to'] = $this->createElement('text', 'to', array(
            'label' => $this->_tlabel.'to',
            'dimension' => 12,
            'filters' => array('StringTrim'),
        ));

        $bool = array('' => '',
                      0 => $this->getView()->translate('label_no'),
                      1 => $this->getView()->translate('label_yes'));

        $fields['is_sent'] = $this->createElement('select', 'is_sent', array(
            'label' => $this->_tlabel.'is_sent',
            'validators' => array(
                array('InArray', true, array(array_keys($bool)))
            ),
            'multiOptions' => $bool
        ));

        $fields['to_send'] = $this->createElement('select', 'to_send', array(
            'label' => $this->_tlabel.'to_send',
            'validators' => array(
                array('InArray', true, array(array_keys($bool)))
            ),
            'multiOptions' => $bool
        ));

        $fields['exception'] = $this->createElement('select', 'exception', array(
            'label' => $this->_tlabel.'exception',
            'validators' => array(
                array('InArray', true, array(array_keys($bool)))
            ),
            'multiOptions' => $bool
        ));

        $fields['created_at_from'] = $this->createElement('DateTimePicker', 'created_at_from', array(
            'label' => $this->_tlabel.'created_at_from',
            'allowEmpty' => true,
            'required' => false,
            'datetime' => array(
                'format' => 'YYYY-MM-DD 00:00',
                'language' => 'pl',
            )
        ));

        $fields['created_at_to'] = $this->createElement('DateTimePicker', 'created_at_to', array(
            'label' => $this->_tlabel.'created_at_to',
            'allowEmpty' => true,
            'required' => false,
            'datetime' => array(
                'format' => 'YYYY-MM-DD 23:59',
                'language' => 'pl',
            )
        ));

        $fields['sent_time_from'] = $this->createElement('DateTimePicker', 'sent_time_from', array(
            'label' => $this->_tlabel.'sent_time_from',
            'allowEmpty' => true,
            'required' => false,
            'datetime' => array(
                'format' => 'YYYY-MM-DD 00:00',
                'language' => 'pl',
            )
        ));

        $fields['sent_time_to'] = $this->createElement('DateTimePicker', 'sent_time_to', array(
            'label' => $this->_tlabel.'sent_time_to',
            'allowEmpty' => true,
            'required' => false,
            'datetime' => array(
                'format' => 'YYYY-MM-DD 23:59',
                'language' => 'pl',
            )
        ));

        $buttons['submit'] = $this->createElement('submit', 'submit', array(
            'label' => 'cms_button_search',
            'type' => 'submit',
            'ignore' => true,
            'class' => 'btn-info',
            'dimension' => 6
        ));

        $buttons['clear'] = $this->createElement('clear', 'clear', array(
            'label' => 'cms_button_clear',
            'ignore' => true,
        ));

        $this->addDisplayGroup(array_merge($fields, $buttons), 'filter-search', array(
            'legend' => $this->_tlabel.'filter-search-form'
        ));

        $this->addHtmlTag( array( $fields['from'] ), array('class' => 'col-md-3') );
        $this->addHtmlTag( array( $fields['to'] ), array('class' => 'col-md-3') );
        $this->addHtmlTag( array( $fields['is_sent'] ), array('class' => 'col-md-2') );
        $this->addHtmlTag( array( $fields['to_send'] ), array('class' => 'col-md-2') );
        $this->addHtmlTag( array( $fields['exception'] ), array('class' => 'col-md-2') );

        $this->addHtmlTag( array( $fields['created_at_from'] ), array('class' => 'col-md-3') );
        $this->addHtmlTag( array( $fields['created_at_to'] ), array('class' => 'col-md-3') );
        $this->addHtmlTag( array( $fields['sent_time_from'] ), array('class' => 'col-md-3') );
        $this->addHtmlTag( array( $fields['sent_time_to'] ), array('class' => 'col-md-3') );

        $this->addHtmlTag( array( $buttons['clear'] ), array('class' => 'col-md-1 pull-right') );
        $this->addHtmlTag( array( $buttons['submit'] ), array('class' => 'col-md-1 pull-right') );

        $this->addHtmlTag(array_merge($fields, $buttons), array('class' => 'row') );
    }
}