<?php
/**
 * Created by JetBrains PhpStorm.
 * User: skotar
 * Date: 08.09.2013
 * Time: 12:55
 * To change this template use File | Settings | File Templates.
 */

class Admin_Form_Label_Filter extends Base_Form_Vertical {

    /**
     * @var bool
     */
    protected $_filter = true;

    public function init()
    {
        $this->setMethod('get');
        $this->setAction('?page=1');
        $fields = array();

        $emptyOpt = array(
            '' => ''
        );

        $labelTypeOptions = $emptyOpt + Label::getTypes();

        $fields['type'] = $this->createElement('select', 'type', array(
            'label' => $this->_tlabel.'type',
            'dimension' => 12,
            'multiOptions' => $labelTypeOptions
        ));

        $fields['label'] = $this->createElement('text', 'label', array(
            'label' => $this->_tlabel.'label',
            'dimension' => 12,
        ));

        $fields['value'] = $this->createElement('text', 'value', array(
            'label' => $this->_tlabel.'translation',
            'dimension' => 12,
        ));

        $moduleList = Base_Module::getModules();
        $moduleOptions = array();
        foreach($moduleList as $module){
            $moduleOptions[$module] = $this->getView()->translate('module_name-' . $module);
        }
        sort($moduleOptions);
        $moduleOptions = array('' => '', 'empty' => $this->getView()->translate('module_name-empty')) + $moduleOptions;

        $fields['module'] = $this->createElement('select', 'module', array(
            'label' => $this->_tlabel.'module',
            'select2' => array(),
            'multiple' => 'multiple',
            'validators' => array(
                array('InArray', true, array(array_keys($moduleOptions)))
            ),
            'placeholder' => $this->getView()->translate('label_admin_label_placeholder_module_empty'),
            'multiOptions' => $moduleOptions,
            'dimension' => 12,
        ));

        $fields['date_from'] = $this->createElement('DateTimePicker', 'date_from', array(
            'label' => $this->_tlabel.'date_from',
            'allowEmpty' => true,
            'required' => false,
            'datetime' => array(
                'format' => 'YYYY-MM-DD 00:00',
                'language' => 'pl',
            )
        ));

        $fields['date_to'] = $this->createElement('DateTimePicker', 'date_to', array(
            'label' => $this->_tlabel.'date_to',
            'allowEmpty' => true,
            'required' => false,
            'datetime' => array(
                'format' => 'YYYY-MM-DD 23:59',
                'language' => 'pl',
            )
        ));

        $buttons['clear'] = $this->createElement('clear', 'clear', array(
            'label' => 'cms_button_clear',
            'ignore' => true,
        ));

        $buttons['submit'] = $this->createElement('submit', 'submit', array(
            'label' => 'button_search',
            'type' => 'submit',
            'ignore' => true,
            'class' => 'btn-info',
            'dimension' => 6,
        ));

        $buttons['submit']->removeDecorator('WrapElement');
        $buttons['clear']->removeDecorator('WrapElement');

        $this->addDisplayGroup(array_merge($fields, $buttons), 'filter-search', array(
            'legend' => $this->_tlabel.'filter-search-form'
        ));

        $this->addHtmlTag( array( $fields['type'] ), array('class' => 'col-md-1') );
        $this->addHtmlTag( array( $fields['label'] ), array('class' => 'col-md-4') );
        $this->addHtmlTag( array( $fields['value'] ), array('class' => 'col-md-4') );
        $this->addHtmlTag( array( $fields['module'] ), array('class' => 'col-md-3') );
        $this->addHtmlTag( array( $fields['date_from'] ), array('class' => 'col-md-5') );
        $this->addHtmlTag( array( $fields['date_to'] ), array('class' => 'col-md-5') );

        $this->addHtmlTag( array( $buttons['clear'] ), array('class' => 'col-md-1 text-right', 'style' => 'margin-top: 25px;') );
        $this->addHtmlTag( array( $buttons['submit'] ), array('class' => 'col-md-1 text-right', 'style' => 'margin-top: 25px;') );

        $this->addHtmlTag(array_merge($fields, $buttons), array('class' => 'row') );
    }
}