<?php


class Admin_Navigation
{

    private $_pages = null;


    public function getPages($namspace = null)
    {
        if(null === $this->_pages){
            $acl = Base_Acl::getInstance();
            Zend_View_Helper_Navigation_HelperAbstract::setDefaultAcl($acl);
            $pages = array();
            $frontController = Zend_Controller_Front::getInstance();
            $modulesEnabled = $frontController->getControllerDirectory();

            foreach($modulesEnabled as $module => $path){
                $filename = $frontController->getModuleDirectory( $module ) . DS . 'config' . DS . 'navigation.php';
                if(file_exists($filename)){
                    $pages_module = include $filename;
                    $pages = array_merge_recursive($pages, $pages_module);
                }
            }

            $this->_pages = $pages['admin'];
        }

        if(null !== $namspace){
            return (array) @$this->_pages[$namspace];
        }else{
            return $this->_pages;
        }
    }



    public function getContainer($namspace = null)
    {
        $container = new Zend_Navigation();
        $container->addPages($this->getPages($namspace));

        return $container;
    }




}