<?php
/**
 * Created by PhpStorm.
 * User: Dawid Przygodzki
 * Date: 2015-06-22
 * Time: 14:21
 */

class Auth_AclResourceController extends Base_Controller_Action_Cms
{
    /**
     * @var $_model AclResource
     */
    private $_model = null;

    public function indexAction()
    {
        $resourceList = AclResource::getResources();

        $this->_model = new AclResource();
        $this->view->form = new Auth_Form_AclResource(array('model' => $this->_model));

        if($this->_request->isPost())
        {
            if($this->view->form->isValid( $this->_request->getPost()))
            {
                $postData = $this->_request->getPost($this->view->form->getElementsBelongTo());

                $this->_model = AclResource::findRecordAll($postData['id_acl_resource']);
                $this->_model->id_parent = empty($postData['id_parent']) ? null : $postData['id_parent'];
                $this->_model->name = $postData['name'];
                $this->_model->text = $postData['text'];
                $this->_model->desc = $postData['desc'];

                $this->_model->save();

                $this->_flash()->success->addMessage('label_cms_save_success');
                $this->_redirector()->gotoRouteAndExit();
            }
        }

        $this->view->form->getDisplayGroup('main')->setLegend($this->view->form->getDisplayGroup('main')->getLegend() . '_index');
        $this->view->aclResourceList = $resourceList;
    }

    public function newAction()
    {
        $this->_model = new AclResource();

        $this->_form($this->_model, 'Auth_Form_AclResource');

        $this->_helper->viewRenderer('acl-resource/form', null);
        $this->view->placeholder('page-title')->set($this->view->translate('page-title_auth_acl_resource_new'));
    }

    public function editAction()
    {
        $this->_model = AclResource::findRecordAll($this->getParam('id_acl_resource'));
        $this->forward403Unless($this->_model);

        $this->_form($this->_model, 'Auth_Form_AclResource');

        $this->_helper->viewRenderer('acl-resource/form', null);
        $this->view->placeholder('page-title')->set($this->view->translate('page-title_auth_acl_resource_edit'));
    }

    public function deleteAction()
    {
        $this->_model = AclResource::findRecordAll($this->getParam('id_acl_resource'));
        $this->forward403Unless($this->_model);

        // set null id_acl_resource for all parent resource item
        $res1 = Doctrine_Query::create()
            ->select('id_acl_resource')
            ->from('AclResource')
            ->where('id_parent = ?', $this->_model->getId())
            ->execute(array(), Doctrine::HYDRATE_SINGLE_SCALAR);

        if(count($res1) > 0)
        {
            Doctrine_Query::create()
                ->update('AclResourceItem')
                ->set('id_acl_resource', 'null')
                ->whereIn('id_acl_resource', $res1)
                ->execute();

            foreach($res1 as $v1)
            {
                $res2 = Doctrine_Query::create()
                    ->select('id_acl_resource')
                    ->from('AclResource')
                    ->where('id_parent = ?', $v1)
                    ->execute(array(), Doctrine::HYDRATE_SINGLE_SCALAR);

                if(count($res2) > 0){
                    Doctrine_Query::create()
                        ->update('AclResourceItem')
                        ->set('id_acl_resource', 'null')
                        ->whereIn('id_acl_resource', $res2)
                        ->execute();
                }
            }
        }

        $this->_model->delete();

        Doctrine_Query::create()
            ->update('AclResourceItem')
            ->set('id_acl_resource', 'null')
            ->where('id_acl_resource = ?', $this->_model->getId())
            ->execute();

        $this->_flash()->success->addMessage('label_cms_delete_success');
        $this->_redirector()->gotoRouteAndExit(array(), 'auth_acl_resource_index');
    }
}