<?php
/**
 * Created by PhpStorm.
 * User: Dawid Przygodzki
 * Date: 2015-06-23
 * Time: 09:04
 */

class Auth_AclResourceItemController extends Base_Controller_Action_Cms
{
    /**
     * @var $_model AclResourceItem
     */
    private $_model = null;

    protected $_modelMassName = 'AclResourceItem';

    protected $_route_return = 'auth_acl_resource_item_index';

    public function indexAction()
    {
        $this->_resourceItemFilter = new Auth_Form_Filter_AclResourceItem();
        $data = $this->_resourceItemFilter->getValues(true);

        $resourceItemList = AclResourceItem::getQuery($data);

        $this->_modelMassActions = array(
            'delete' => $this->view->translate('label_mass-action_delete')
        );

        $this->view->aclResourceItemList = $this->_helper->paging($resourceItemList, array('limit' => 50));
        $this->view->formFilter = $this->_resourceItemFilter;
        $this->view->modelMassActions = $this->_modelMassActions;
    }

    public function newAction()
    {
        $this->_model = new AclResourceItem();

        $this->_form($this->_model, 'Auth_Form_AclResourceItem');

        $this->_helper->viewRenderer('acl-resource-item/form', null);
        $this->view->placeholder('page-title')->set($this->view->translate('page-title_auth_acl_resource_item_new'));
    }

    public function editAction()
    {
        $this->_model = AclResourceItem::findRecordAll($this->getParam('id_acl_resource_item'));
        $this->forward403Unless($this->_model);

        $this->_form($this->_model, 'Auth_Form_AclResourceItem');

        $this->_helper->viewRenderer('acl-resource-item/form', null);
        $this->view->placeholder('page-title')->set($this->view->translate('page-title_auth_acl_resource_item_edit'));
        $this->view->aclResourceItem = $this->_model;
    }

    public function deleteAction()
    {
        $this->_model = AclResourceItem::findRecordAll($this->getParam('id_acl_resource_item'));
        $this->forward403Unless($this->_model);

        $this->_model->delete();

        $this->_flash()->success->addMessage('label_cms_delete_success');
        $this->_redirector()->gotoRouteAndExit(array(), 'auth_acl_resource_item_index');
    }
} 