<?php
/**
 * Created by JetBrains PhpStorm.
 * User: Robert Rogi�ski <robert.roginski@gmail.com>
 * Date: 01.07.13
 * Time: 19:26
 * To change this template use File | Settings | File Templates.
 */

class Auth_Form_AclRole extends Base_Form_Horizontal{

    /**
     * @var AclRole
     */
    protected $_model;

    public function init()
    {
        $fields = array();

        if(Base_Auth::MAIN_ROLE != $this->_model->getName()){
            $roleOptions = array('' => '') + AclRole::getListParent($this->_model->id_acl_role);
            $fields['id_parent'] = $this->createElement( 'select', 'id_parent', array(
                'label' => $this->_tlabel.'id_parent',
                'required' => false,
                'allowEmpty' => true,
                'multiOptions' => $roleOptions,
                'placeholder' => $this->getView()->translate('label_auth_acl_role_form_placeholder_id_parent'),
                'validators' => array(
                    array('NotEmpty', true),
                    array('InArray', true, array(array_keys($roleOptions)))
                ),
                'select2' => array(
                    'allowClear' => true,
                    'placeholder' => $this->getView()->translate('label_auth_acl_role_form_placeholder_id_parent'),
                ),
                'value' => $this->_model->getIdParent(),
            ));
        }

        $fields['name'] = $this->createElement('text', 'name', array(
            'label' => $this->_tlabel.'name',
            'allowEmpty' => false,
            'dimension' => 12,
            'required' => true,
            'filters' => array('StringTrim'),
            'validators' => array(
                array('NotEmpty', true),
                array('AlreadyTaken', true, array( 'model' => 'AclRole', 'column' => 'name')),
                array('Regex', true, array('pattern' => '/^[(a-zA-Z0-9)_-]+$/'))
            ),
            'value' => $this->_model->getName(),
        ));

        $fields['submit'] = $this->createElement('submit', 'submit', array(
            'label' => 'cms_button_save'
        ));

        $this->addDisplayGroup($fields, 'main', array(
            'legend' => $this->_tlabel.'group_acl-role'
        ));
    }
}
