<?php

/**
 * Created by PhpStorm.
 * User: Dawid Przygodzki
 * Date: 2015-08-12
 * Time: 13:26
 */
class Auth_Form_Filter_AclResourceItem extends Base_Form_Vertical {

    /**
     * @var bool
     */
    protected $_filter = true;

    public function init()
    {
        $this->setMethod('get');
        $this->setAction('?page=1');
        $fields = array();

        $fields['search'] = $this->createElement('text', 'search', array(
            'label' => $this->_tlabel.'search',
            'dimension' => 12,
            'filters' => array('StringTrim'),
            'size' => 8,
            'label-size' => 4,
        ));

        $fields['not_resource'] = $this->createElement('checkbox', 'not_resource', array(
            'label' => $this->_tlabel.'not_resource',
            'class' => 'iCheck',
            'value' => false,
            'size' => 12,
        ));

        $resourceList = array('' => '') + AclResource::getListArray();
        $fields['id_acl_resource'] = $this->createElement('select', 'id_acl_resource', array(
            'label' => $this->_tlabel.'id_acl_resource',
            'allowEmpty' => true,
            'multiOptions' => $resourceList,
            'select2' => array(
                'allowClear' => true,
                'placeholder' => $this->getView()->translate('label_acl_resource_item_resource_empty'),
            ),
            'validators' => array(
                array('InArray', true, array(array_keys($resourceList)))
            ),
            'size' => 8,
            'label-size' => 4,
        ));

        $buttons['submit'] = $this->createElement('submit', 'submit', array(
            'label' => 'cms_button_search',
            'type' => 'submit',
            'ignore' => true,
            'class' => 'btn-info',
            'dimension' => 6
        ));

        $buttons['clear'] = $this->createElement('clear', 'clear', array(
            'label' => 'cms_button_clear',
            'ignore' => true,
        ));

        $this->addDisplayGroup(array_merge($fields, $buttons), 'filter-search', array(
            'legend' => $this->_tlabel.'filter-search-form',
            'class' => 'panel-primary'
        ));

        $this->addHtmlTag( array( $fields['search'] ), array('class' => 'col-md-7 col-sm-6 col-xs-12') );
        $this->addHtmlTag( array( $fields['not_resource'] ), array('class' => 'col-md-1 col-sm-2 col-xs-3') );
        $this->addHtmlTag( array( $fields['id_acl_resource'] ), array('class' => 'col-md-4 col-sm-4 col-xs-9') );
        $this->addHtmlTag( $fields, array('class' => 'row') );
        $this->addHtmlTag( $fields, array('class' => 'col-md-12') );

        $this->addHtmlTag(array( $buttons['clear'] ), array('class' => 'col-md-1 pull-right'));
        $this->addHtmlTag(array( $buttons['submit'] ), array('class' => 'col-md-1 pull-right'));

        $this->addHtmlTag(array_merge($fields, $buttons), array('class' => 'row') );
    }
}