<?php

class Filemanager_Form_Catalog extends Base_Form_Horizontal
{

    private $_destination;

    protected function setDestination($destination)
    {
        $this->_destination = $destination;
    }

    public function init()
    {
        $fields['name'] = $this->createElement( 'text', 'name', array(
            'label' => $this->_tlabel.'name',
            'required' => true,
            'allowEmpty' => false,
            'filters' => array('StringTrim'),
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', true, array('max' => 255)),
                array('File_NotExists', true, array('destination' => $this->_destination))
            ),
            'dimension' => 3
        ));

        $fields['submit'] = $this->createElement('submit', 'submit');

        $this->addDisplayGroup($fields, 'main');
    }


    public function postIsValid($data)
    {

        $name = Base::getFriendlyUri($this->getValue('name'));
        Base::createDir($this->_destination.DS.$name);

        return true;
    }


}