<?php

class Filemanager_Form_File extends Base_Form_Horizontal
{
    private $_destination;

    protected function setDestination($destination)
    {
        $this->_destination = $destination;
    }

    public function init()
    {
        $fields['file'] = $this->createElement( 'file', 'file', array(
            'label' => $this->_tlabel.'file',
            'required' => true,
            'allowEmpty' => false,
            'destination' => $this->_destination,
            'validators' => array(
                array('File_NotExists', true, array('destination' => $this->_destination)),
                array('File_ExcludeExtension', true, 'exe,php,php5,php4'),
                array('File_MaxPostSize', true, array()),
            ),
            'dimension' => 3,
            'filestyle' => array(
                'buttonText' => $this->getView()->translate('button_browse_file'),
                'size' => 'sm',
                'buttonName' => 'btn-primary',
                'buttonBefore' => true,
            ),
        ));

        $filed_desc = $this->getView()->translate($this->_tlabel.'file-desc').' '.$fields['file']->getMaxFileSizeSimply();
        $fields['file']->setDescription($filed_desc);

        $fields['submit'] = $this->createElement('submit', 'submit');

        $this->addDisplayGroup($fields, 'main');
    }


    public function postIsValid($data)
    {
        $adapter =  $this->file->getTransferAdapter();
        $fileInfo = $adapter->getFileInfo();
        $ext = pathinfo($fileInfo['file']['name'], PATHINFO_EXTENSION);
        $name = pathinfo($fileInfo['file']['name'], PATHINFO_FILENAME);
        $name = Base::getFriendlyUri($name);

        $adapter->addFilter('Rename', $this->_destination.DS.$name.'.'.$ext, 'file');

        return true;
    }


}