<?php

class Filemanager_Form_NameEdit extends Base_Form_Horizontal
{

    private $_element;

    protected function setElement($element)
    {
        $this->_element = $element;
    }

    public function init()
    {

        $fileNotExists = new Base_Validate_File_NotExists(array('destination' => $this->_element['full_path']));
        $fileNotExists->setExtension($this->_element['ext']);

        $fields['name'] = $this->createElement( 'text', 'name', array(
            'label' => $this->_tlabel.'name',
            'required' => true,
            'value' => $this->_element['name'],
            'allowEmpty' => false,
            'filters' => array('StringTrim'),
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', true, array('max' => 255)),
                array($fileNotExists, true)
            ),
            'dimension' => 3
        ));

        $fields['submit'] = $this->createElement('submit', 'submit');

        $this->addDisplayGroup($fields, 'main');
    }


    public function postIsValid($data)
    {
        $newName = Base::getFriendlyUri($this->getValue('name'));
        if($this->_element['name'] != $newName){
            $filename_old = $this->_element['full_path'].$this->_element['name'].$this->_element['ext'];
            $filename_new = $this->_element['full_path'].$newName.$this->_element['ext'];

            rename($filename_old, $filename_new);
        }


        return true;
    }


}