<?php

/**
 * Image
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    ##PACKAGE##
 * @subpackage ##SUBPACKAGE##
 * @author     ##NAME## <##EMAIL##>
 * @version    SVN: $Id: Builder.php 7490 2010-03-29 19:53:27Z jwage $
 */
class Image extends Table_Image
{

    const SECRET_KEY = '98asdf;**&**&&fasf__--)))999%$saasddd...9';

    const RESIZE_ORYGINAL 			= 'o';
    const RESIZE_NO 				= 'n';
    const RESIZE_CROP 				= 'c';
    const RESIZE_TO_WIDTH 			= 'w';
    const RESIZE_TO_HEIGHT 			= 'h';
    const RESIZE_TO_BOTH			= 'b';
    const RESIZE_TO_BOTH_IF_BIGGER  = 'bi';
    const RESIZE_TO_BOTH_AND_FILL	= 'm';
    const RESIZE_ADAPTIVE			= 'a';

    CONST PARAM_PERSPECTIVE = 'p';
    CONST PARAM_CROP = 'c';



    public function getParams($params = array())
    {
        $default = array( 'resize' => 'b', 'width' => 100, 'height' => 100 );
        $img_params = array();
        if(!empty($this->params)){
            $img_params = json_decode($this->params, true);
        }

        return array_merge($default, $img_params, $params);
    }

    /**
     * @param array $params
     * @return Image
     */
    public function setParams($params = array())
    {
        $this->params = json_encode($params);
        return $this;
    }



    public static function getHashKey($params)
    {
        return substr(md5(self::SECRET_KEY.implode('-',$params)), 0, 5);
    }


    public static function getMainImages($channel, array $object_ids = array())
    {
        $images = Doctrine_Query::create()
            ->from('Image i INDEXBY i.id_image')
            ->where('i.channel = ?', $channel)
            ->whereIn('object_id', $object_ids)
            ->execute(array(), Doctrine::HYDRATE_ARRAY);

        $minInObject = array();
        foreach($images as $id_image => $image){
            if(empty($minInObject[$image['object_id']]) ||
                $image['order'] < $images[$minInObject[$image['object_id']]['id_image']]['order'] ){
                $minInObject[$image['object_id']] = $image;
            }
        }


        return $minInObject;
    }


    public static function getMainImage($channel, $object_id = null)
    {
        $query = Doctrine_Query::create()
            ->select('id_image')
            ->from(__CLASS__)
            ->where('channel = ?', $channel)
            ->addWhere('is_main = 1')
            ->limit(1);

        if($object_id){
            $query->addWhere('object_id = ?', $object_id);
        }

        $result = $query->execute(array(), Doctrine::HYDRATE_ARRAY);

        if(isset($result[0]['id_image'])){
            return $result[0]['id_image'];
        }

        return false;
    }


    /**
     * @param $channel
     * @param $data
     * @param null $object_id
     * @param null $title
     * @param null $desc
     * @return Image
     * @throws Exception
     */
    public static function createImage($channel, $data, $object_id = null, $title = null, $desc = null)
    {
        $imageTypes = array(
            'image/jpeg'    => 'jpg',
            'image/jpg'     => 'jpg',
            'image/pjpeg'   => 'jpg',
            'image/png'     => 'png',
            'image/gif'     => 'gif',
            'image/x-png'   => 'png',
        );

        $extension = isset($imageTypes[$data['type']]) ? $imageTypes[$data['type']] : 'jpg';
        if(!isset($data['save'])){ $data['save'] = true; }
        $_channel_name = $channel;

        if($channel instanceof Base_Doctrine_Record){
            $_channel_name = get_class($channel);
            if(null === $object_id && !$channel->isNew()){
                $object_id = $channel->getId();
            }
        }


        if(!file_exists($data['source'])) {
            throw new Exception('Plik "'.$data['source'].'" nie istnieje.');
        }

        $targetDir = "/data/images/".date('Y-m');
        Base::createDir(ROOT_PATH.$targetDir);

        $newName = Base::getUniqueFileName((string) $object_id, $data['name'], $extension);
        $filePath = $targetDir . '/' . $newName;

        $rename = new Zend_Filter_File_Rename(array('target' => ROOT_PATH . $filePath));
        $rename->filter($data['source']);

        $image = new Image();
        $image->type = $data['type'];
        $image->key = Base::randString(5);
        $image->file_path = $filePath;
        $image->hash = md5_file(ROOT_PATH . $filePath);
        $image->order = 1;
        $image->object_id = $object_id;
        $image->channel = $_channel_name;

        $isMain = isset($data['is_main']) ? $data['is_main'] : !self::getMainImage($_channel_name, $object_id);
        if($isMain){
            $image->is_main = true;
        }


        if(!empty($title)){ $image->setTitle($title); }
        if(!empty($desc)){ $image->setDesc($desc); }

        if($data['save']){
            $image->save();
        }

        if($isMain){
            Doctrine_Query::create()
                ->update(__CLASS__)
                ->set('is_main', '?', 0)
                ->where('channel = ? AND object_id = ? AND id_image != ?',
                    array($image->channel, $image->object_id, $image->getId()))
                ->execute();
        }



        return $image;
    }


    public function postUpdate($event)
    {
        Base_EventManager::trigger('imageUpdate', $this->getId());
    }


    public function postDelete($event)
    {
        Base_EventManager::trigger('imageDelete', $this->getId());
        @unlink(ROOT_PATH.$this->file_path);
    }

    public function getOrginalUrl()
    {
        return self::getUrl($this->getId(), array('resize' => self::RESIZE_ORYGINAL));
    }

    /**
     * Zwraca adres url do zdjęcia. Sposób wywołania
     * 1) Service_Image::getUrl($id, $width, $height, $resize, $format)
     * 2) Service_Image::getUrl($id, array('width' => 100, 'height' => 100, 'format' => 'png'))
     *
     * @param int $id
     * @param int $width
     * @param int $height
     * @param string $resize
     *
     * @param int $id
     * @param array $params array( 'width' => 100, 'height' => 100 )
     *
     * @return string
     */
    public static function getUrl()
    {
        $options = array(
            'id' => null,
            'resize' => 'b',
            'width' => 100,
            'height' => 100,
            'format' => 'jpg',
            'params' => array(),
        );

        $args = $params = func_get_args();
        $options['id'] = array_shift($params);
        $params = array_shift($params);

        if(!is_array($params)){
            if(isset($args[1])){ $options['width'] = $args[1]; }
            if(isset($args[2])){ $options['height'] = $args[2]; }
            if(isset($args[3])){ $options['resize'] = $args[3]; }
            if(isset($args[4])){ $options['format'] = $args[4]; }
        }else{
            $options = array_merge($options, $params);

            if(isset($params[Image::PARAM_PERSPECTIVE])){
                $options['params'][] = Image::PARAM_PERSPECTIVE.$params[Image::PARAM_PERSPECTIVE];
                unset($options[Image::PARAM_PERSPECTIVE]);
            }

            if(isset($params[Image::PARAM_CROP])){
                if(is_array($params[Image::PARAM_CROP])){
                    $params[Image::PARAM_CROP] =
                        $params[Image::PARAM_CROP]['x'] . ',' . $params[Image::PARAM_CROP]['y'] . ',' .
                        $params[Image::PARAM_CROP]['width'].','.$params[Image::PARAM_CROP]['height'];
                }
                $options['params'][] = Image::PARAM_CROP.$params[Image::PARAM_CROP];
                unset($options[Image::PARAM_CROP]);
            }
        }

        $options['params'] = join('-', $options['params']);
        $options['key'] = self::getHashKey($options);

        $url = Zend_Controller_Action_HelperBroker::getStaticHelper('Url');
        return $url->url($options, 'cdn', true, false);
    }

    /**
     * @param object|integer $object
     * @return bool
     * @throws Exception
     */
    public static function checkImageExist($object)
    {
        if ( null == $object ) {
            return false;
        }

        if(is_int($object) || !isset($object['file_path'])){
            $object = self::find($object, array('translations_leftJoin' => true));
        }

        if($object)
        {
            if(file_exists(ROOT_PATH.$object['file_path'])) {
                return true;
            }
        }
        return false;
    }

}