<?php
/**
 * Created by JetBrains PhpStorm.
 * User: skotar
 * Date: 16.08.2013
 * Time: 00:32
 * To change this template use File | Settings | File Templates.
 */

class Navigation_AdminController extends Base_Controller_Action_Cms
{
    /**
     * @var Navigation
     */
    private $_navigation = null;

    /**
     * @var Doctrine_Collection
     */
    private $_navigationList;

    protected $_route_return = 'navigation_admin';

    public function preDispatch()
    {
        $this->_navigationList = Doctrine_Query::create()
            ->select('o.*, t.pages as pages')
            ->from('Navigation o INDEXBY n.id_navigation')
            ->leftJoin('o.Translations t WITH t.id_language = ?', Base_I18n::getLangId())
            ->execute(array(), Doctrine::HYDRATE_ARRAY);

        parent::preDispatch();
    }

    public function postDispatch()
    {
        $this->view->navigationList = $this->_navigationList;
        parent::postDispatch();
    }


    public function indexAction()
    {
        if($this->hasParam('id_navigation') && isset($this->_navigationList[$this->getParam('id_navigation')])){
            $this->_navigation = $this->_navigationList[$this->getParam('id_navigation')];
        }

        if (!$this->_navigation && !empty($this->_navigationList)) {
            $this->_navigation = $this->_navigationList[key($this->_navigationList)];
        }

        if($this->_navigation){
            $this->view->form = new Navigation_Form_NavItem();
            $this->view->pages = (array) @json_decode($this->_navigation['pages'], true);

            $this->view->placeholder( 'page-title' )->set($this->_navigation['name']);
        } else {
            $this->view->placeholder( 'page-title' )->set( $this->view->translate('page-title_navigation-list') );
        }

        $this->view->navigation = $this->_navigation;
    }


    public function saveListAction()
    {
        $this->_navigation = Navigation::findRecordAll($this->getParam('id_navigation'));
        $this->forward404Unless($this->_navigation);

        $pages = (array) @$this->getParam('Navigation_Form_List');
        $pages = (array) @$pages['pages'];

        $this->_navigation->setPages($pages);
        $this->_navigation->save();

        $this->_helper->json(array(
            'status' => true,
            'gritter_title' => $this->view->translate('gritter-title_record_save'),
            'gritter_text' => $this->view->translate('gritter-text_record_save'),
        ));
    }


    public function newAction()
    {
        $this->_navigation = new Navigation();

        $this->_form($this->_navigation, 'Navigation_Form_Navigation');
        $this->view->placeholder( 'page-title' )->set( $this->view->translate('cms-page-title_navigation_new-form') );
    }

    public function editAction()
    {
        $this->_navigation = Navigation::findRecordAll($this->getParam('id_navigation'));
        $this->forward404Unless($this->_navigation);

        $this->_form($this->_navigation, 'Navigation_Form_Navigation');
        $this->view->placeholder( 'page-title' )->set( $this->view->translate('cms-page-title_navigation_edit-form') );
    }

    public function deleteAction()
    {
        $this->_navigation = Navigation::findRecordAll($this->getParam('id_navigation'));
        $this->forward404Unless($this->_navigation);

        $this->_navigation->delete();

        $this->_flash()->success->addMessage('label_cms_delete_success');
        $this->_redirector()->gotoRouteAndExit(array(), 'navigation_admin');
    }
}