<?php
/**
 * Created by PhpStorm.
 * User: Dawid Przygodzki
 * Date: 2015-03-03
 * Time: 13:46
 */

class Navigation_AdminMigrationController extends Base_Controller_Action_Cms
{
    public function init(){}

    /**
     * @throws Doctrine_Query_Exception
     */
    public function migrationAction()
    {
        $this->view->layout()->disableLayout();
        $this->_helper->viewRenderer->setNoRender();

        $this->_navigationList = Navigation::getQuery()->execute(array(), Doctrine::HYDRATE_RECORD);

        foreach($this->_navigationList as $navigation) /* @var $navigation Navigation */
        {
            $pages_navigation = $navigation['pages'];

            if(!empty($pages_navigation)){
                $ids_languages = Base_I18n::getIdsLanguages();
                foreach($ids_languages as $id => $name)
                {
                    /* @var $translation NavigationTranslation */
                    if($navigation->getTransaltion($id) instanceof NavigationTranslation)
                    {
                        $translation = $navigation->getTransaltion($id);
                        $label = (array) json_decode($translation->getPages(), true);

                        $pages = $this->_hydratePages((array) json_decode($pages_navigation, true), $label);

                        $translation->setPages(json_encode($pages));
                    }
                }

                $navigation->pages = NULL;
                $navigation->save();
            }
        }

        $this->_flash()->success->addMessage('navigation_migration_success');
        $this->_redirector()->gotoRouteAndExit(array(), 'navigation_admin');
    }

    /**
     * @param $pages
     * @param $label
     * @return array
     */
    private function _hydratePages($pages, $label)
    {
        $result = array();
        foreach($pages as $key => $value)
        {
            $result[$key] = $value;
            $result[$key]['label'] = $label[$key];

            if(isset($value['pages'])){
                $result[$key]['pages'] = $this->_hydratePages($value['pages'], $label);
            }
        }

        return $result;
    }
} 