<?php

class Navigation_Form_NavItem extends Base_Form_Horizontal
{
    public function init()
    {
        parent::init();
        $this->setAction('#');
        $this->setAttrib('id', 'Navigation_Form_NavItem');
        $this->setElementsBelongTo('');

        $fields = array();

        $fields['get-item'] = $this->createElement( 'html', 'get-item', array(
            'allowEmpty' => false,
            'ignore' => true,
            'value' => '<a data-fancybox-type="iframe" href="'
                .Base::url('admin_cms-shere-elements')
                .'" class="btn btn-info getSherePointItem">'
                .$this->getView()->translate($this->_tlabel.'get-item')
                .' <i class="glyphicon glyphicon-download"></i></a>',
        ));
        $fieldSizeDecorator = $fields['get-item']->getDecorator('FieldSize');
        $fieldSizeDecorator->setOption('class', 'col-md-offset-2 col-md-10');

        $fields['label'] = $this->createElement( 'text', 'label', array(
            'label' => $this->_tlabel.'label',
            'allowEmpty' => false,
            'filters' => array('StringTrim'),
        ));

        $fields['uri'] = $this->createElement( 'text', 'uri', array(
            'label' => $this->_tlabel.'uri',
            'filters' => array('StringTrim'),
        ));


        $fields['route'] = $this->createElement( 'text', 'route', array(
            'label' => $this->_tlabel.'route',
            'filters' => array('StringTrim'),
            'disable' => !DEBUG,
        ));

        $fields['resource'] = $this->createElement( 'text', 'resource', array(
            'label' => $this->_tlabel.'resource',
            'filters' => array('StringTrim'),
            'disable' => !DEBUG,
        ));

        $fields['class'] = $this->createElement( 'text', 'class', array(
            'label' => $this->_tlabel.'class',
            'filters' => array('StringTrim'),
            'disable' => !DEBUG,
        ));

        $fields['target'] = $this->createElement( 'checkbox', 'target', array(
            'label' => $this->_tlabel.'target',
            'class' => 'iCheck',
        ));

        $fields['icon'] = $this->createElement('text', 'icon', array(
            'label' => $this->_tlabel.'icon_class',
            'filters' => array('StringTrim'),
        ))->setDescription('navigation_form_navitem_icon_class_desc');

        $fields['icon_awesome'] = $this->createElement('text', 'icon_awesome', array(
            'label' => $this->_tlabel.'icon_awesome',
            'filters' => array('StringTrim'),
        ))->setDescription('navigation_form_navitem_icon_awesome_desc');

        $fields['params'] = new Navigation_Form_Element_TreeItemParams('params', array(
            'label' => $this->_tlabel.'params',
//            'decorators' => $this->_elementDecorators,
            'disable' => !DEBUG,
        ));

        if(!DEBUG) {
            $fields['route']->setAttrib('placeholder', $this->getView()->translate($this->_tlabel . 'only_in_debug'));
            $fields['resource']->setAttrib('placeholder', $this->getView()->translate($this->_tlabel . 'only_in_debug'));
            $fields['class']->setAttrib('placeholder', $this->getView()->translate($this->_tlabel . 'only_in_debug'));
            $fields['params']->setAttrib('placeholder', $this->getView()->translate($this->_tlabel . 'only_in_debug'));
        }

        $fields['submit'] = $this->createElement('submit', 'submit', array(
            'label' => $this->_tlabel.'submit',
            'ignore' => true,
            'class' => 'btn btn-success',
            'dimension' => 4,
            'loader' => 'false'
        ));

        $this->addDisplayGroup($fields, 'main', array(
            'legend' => $this->_tlabel.'group_std',
        ));
    }


}