<?php

class Navigation_Form_Navigation extends Base_Form_Horizontal
{

    /**
     * @var Navigation
     */
    protected $_model;


    public function init()
    {
        $fields = array();

        $fields['name'] = $this->createElement( 'text', 'name', array(
            'label' => $this->_tlabel.'name',
            'required' => true,
            'allowEmpty' => false,
            'dimension' => 4,
            'filters' => array('StringTrim'),
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', true, array('max' => 255))
            ),
            'value' => $this->_model->getName(),
        ));

        $fields['class'] = $this->createElement( 'text', 'class', array(
            'label' => $this->_tlabel.'class',
            'required' => false,
            'allowEmpty' => true,
            'filters' => array('StringTrim'),
            'dimension' => 4,
            'validators' => array(
                array('StringLength', true, array('max' => 255))
            ),
            'value' => $this->_model->getClass(),
        ));

        $fields['submit'] = $this->createElement('submit', 'submit', array(
            'label' => 'cms_button_save',
            'dimension' => 2,
        ));


        $this->addDisplayGroup($fields, 'main', array(
            'legend' => $this->_tlabel.'group_std',
        ));

//        $this->setAttrib('class', $this->getAttrib('class').' ajax');
        $this->setAttrib('id', $this->getElementsBelongTo());
//        $this->setAttrib('data-replace', '#'.$this->getElementsBelongTo());
    }

    protected function postIsValid($data)
    {
        parent::postIsValid($data);

        $this->_model->save();

        if ( $this->_model->isNew() ) {
            $this->_model->Translations[Base_I18n::getLangId()] = new NavigationTranslation();
            $this->_model->Translations[Base_I18n::getLangId()]->setIdNavigation($this->_model->getId());
            $this->_model->Translations[Base_I18n::getLangId()]->setIdLanguage(Base_I18n::getLangId());
        }

        return true;
    }
}