<?php
/**
 * Created by PhpStorm.
 * User: Robert
 * Date: 14.06.14
 * Time: 15:25
 */

class Navigation_Breadcrumb {

    private $_breadcrumb = array();

    /**
     * Singleton instance
     *
     * @var Navigation_Breadcrumb
     */
    protected static $_instance = null;

    /**
     * Singleton pattern implementation makes "new" unavailable
     *
     * @return void
     */
    protected function __construct()
    {}

    /**
     * Singleton pattern implementation makes "clone" unavailable
     *
     * @return void
     */
    protected function __clone()
    {}

    /**
     * Returns an instance of Base_Storage
     *
     * Singleton pattern implementation
     *
     * @return Navigation_Breadcrumb Provides a fluent interface
     */
    public static function getInstance()
    {
        if (null === self::$_instance) {
            self::$_instance = new self();
        }

        return self::$_instance;
    }


    /**
     * Returns an instance of Navigation_Breadcrumb
     *
     * Singleton pattern implementation
     *
     * @return Navigation_Breadcrumb Provides a fluent interface
     */
    public static function _()
    {
        return self::getInstance();
    }


    /**
     * @param $item array
     * @return $this
     */
    public function add($item)
    {
        $this->_breadcrumb[] = $item;

        return $this;
    }


    public function getBreadcrumb()
    {
        return $this->_breadcrumb;
    }


} 