<?php
/**
 * Created by JetBrains PhpStorm.
 * User: skotar
 * Date: 22.09.2013
 * Time: 14:48
 * To change this template use File | Settings | File Templates.
 */

class News_AdminCategoryController extends Base_Controller_Action_Cms {
    /**
     * @var NewsCategory
     */
    private $_newsCategory;

    /**
     * @var News_Form_Admin_NewsCategory
     */
    private $_formNewsCategory;

    protected $_modelMassName = 'NewsCategory';

    protected $_massActionMode = 'off';

    protected $_massActionModeType = array('on','off');

    protected $_mode;

    protected $_route_return = 'news-category_admin';

    public function indexAction()
    {
        $this->_mode = $this->getParam('mode');
        if($this->_mode == 'get'){
            $this->_navLeftDisplay = false;
            Base_Layout::setLayout('Admin', 'layout_empty');
        }

        if($this->getParam('mass_action_mode'))
        {
            $this->_massActionMode = $this->getParam('mass_action_mode');
        }

        if(!in_array($this->_massActionMode,$this->_massActionModeType))
        {
            $this->_massActionMode = 'off';
        }

        $newsCategoryFilter = new News_Form_Admin_Filter_NewsCategory();
        $data = $newsCategoryFilter->getValues();
        $data = $data[$newsCategoryFilter->getElementsBelongTo()] + array('left_join' => '');

        $query = NewsCategory::getQuery($data)
            ->addSelect('COUNT(n.id_news) as count_news')
            ->leftJoin('o.News n')
            ->groupBy('o.id_news_category');

        $this->_modelMassActions = array(
            'active' => $this->view->translate('label_mass-action_active'),
            'disActive' => $this->view->translate('label_mass-action_disactive'),
            'delete' => $this->view->translate('label_mass-action_delete')
        );

        $this->view->newsCategoryList = $this->_helper->paging($query);
        $this->view->formFilter = $newsCategoryFilter;
        $this->view->mode = $this->_mode;
        $this->view->actionMode = $this->_massActionMode;
        $this->view->modelMassActions = $this->_modelMassActions;
    }

    public function newAction()
    {
        $this->_newsCategory = new NewsCategory;
        $this->_form($this->_newsCategory, 'News_Form_Admin_NewsCategory');
        $this->view->placeholder( 'page-title' )->set( $this->view->translate('cms-page-title_news_category-new') );
    }

    public function editAction()
    {
        $this->_newsCategory = NewsCategory::findRecordAll($this->_getParam('id'));
        $this->forward403Unless($this->_newsCategory);

        $this->_form($this->_newsCategory, 'News_Form_Admin_NewsCategory');
        $this->view->placeholder( 'page-title' )->set( $this->view->translate('cms-page-title_news_category-edit') );
    }


    public function deleteAction()
    {
        $this->_newsCategory = NewsCategory::findRecordAll($this->_getParam('id'));
        $this->forward403Unless($this->_newsCategory);

        $this->_newsCategory->delete();

        $this->_flash()->success->addMessage('label_cms_delete_success');
        $this->_redirector()->gotoRouteAndExit(array(), 'news-category_admin');
    }
}