<?php
/**
 * Created by PhpStorm.
 * User: Dawid Przygodzki
 * Date: 2015-02-24
 * Time: 14:15
 */

class News_AdminCommentController extends Base_Controller_Action_Cms
{
    /**
     * @var NewsComment
     */
    private $_model;

    /**
     * @var News
     */
    private $_news;

    protected $_modelMassName = 'NewsComment';

    protected $_massActionMode = 'off';

    protected $_massActionModeType = array('on','off');

    public function indexAction()
    {
        if($this->getParam('mass_action_mode'))
        {
            $this->_massActionMode = $this->getParam('mass_action_mode');
        }

        if(!in_array($this->_massActionMode,$this->_massActionModeType))
        {
            $this->_massActionMode = 'off';
        }

        $commentFilter = new News_Form_Admin_Filter_Comment();
        $data = $commentFilter->getValues(true);

        $query = NewsComment::getQuery($data);

        $this->_modelMassActions = array(
            'delete' => $this->view->translate('label_mass-action_delete')
        );

        $this->view->newsComment = $this->_helper->paging($query);
        $this->view->formFilter = $commentFilter;
        $this->view->modelMassActions = $this->_modelMassActions;
    }

    public function showAction()
    {
        Base_Layout::setLayout('Admin', 'layout_empty');

        $this->_model = NewsComment::find($this->getParam('id_news_comment'));
        $this->forward403Unless($this->_model);

        $this->view->comment = $this->_model;
    }

    public function deleteAction()
    {
        $this->_model = NewsComment::findRecordAll($this->getParam('id_news_comment'));
        $this->forward403Unless($this->_model);

        $this->_model->delete();
        $this->_flash()->success->addMessage('label_cms_delete_success');
        $this->_redirector()->gotoRouteAndExit(array(), 'news_admin_comment_index');
    }

    public function setStatusAction()
    {
        $id_news_comment = $this->getParam('id_news_comment');
        $this->_model = NewsComment::findRecord($id_news_comment);
        $this->forward403Unless($this->_model);

        $this->_model->id_news_comment_status = $this->getParam('id_news_comment_status');
        $this->_model->save();

        $this->_redirector()->gotoRouteAndExit(array('id_news_comment' => $id_news_comment), 'news_admin_comment_show');
    }
} 