<?php
/**
 * Created by JetBrains PhpStorm.
 * User: skotar
 * Date: 16.08.2013
 * Time: 00:32
 * To change this template use File | Settings | File Templates.
 */

class News_AdminController extends Base_Controller_Action_Cms {

    /**
     * @var News
     */
    private $_model;

    protected $_modelMassName = 'News';

    protected $_route_return = 'news_admin';

    private $_mode = null;

    public function init()
    {
        parent::init();
        $return = $this->getParam('return');
        $return = explode('/', $return);
        $return = end($return);
        if ( $return == 'comments' ) {
            $this->_modelMassName = 'NewsComments';
        }

        $this->_queryFilterClassName = Setting::getFormClass('News_Form_Admin_Filter_News');
    }

    public function indexAction()
    {
        $this->_mode = $this->getParam('mode');
        if ($this->_mode == 'get') {
            $this->_navLeftDisplay = false;
            Base_Layout::setLayout('Admin', 'layout_empty');
        }

        $formFilter = new $this->_queryFilterClassName(array('listData' => $this->_listData));
        $data = $formFilter->getValuesQuery(true) + array('translations_leftJoin' => true);

        $query = News::getQuery($data)
            ->addSelect('nct.name as category_name')
            ->leftJoin('o.NewsCategory nc')
            ->leftJoin('nc.Translations nct WITH nct.id_language = ?', Base_I18n::getLangId());

        $this->_modelMassActions = array('save' => $this->view->translate('label_mass-action_save')) + $this->_modelMassActions;

        $this->view->newsList = $this->_helper->paging($query, array('limit' => 10));
        $this->view->formFilter = $formFilter;
        $this->view->mode = $this->_mode;
    }

    public function newAction()
    {
        $this->_model = new News;
        $this->_form($this->_model, 'News_Form_Admin_News');

        $this->view->placeholder( 'page-title' )->set( $this->view->translate('cms-page-title_news_new') );
        $this->_helper->viewRenderer('admin/form');
    }

    public function editAction()
    {
        $this->_model = News::findRecordAll($this->_getParam('id'));
        $this->forward403Unless( $this->_model );

        $this->_form($this->_model, 'News_Form_Admin_News');

        $this->view->news = $this->_model;
        $this->_helper->viewRenderer('admin/form');
    }

    public function deleteAction()
    {
        $this->_model = News::findRecordAll( $this->_getParam( 'id' ) );
        $this->forward403Unless( $this->_model );

        $this->_model->delete();

        $this->_flash()->success->addMessage('label_cms_delete_success');
        $this->_redirector()->gotoRouteAndExit(array(), 'news_admin');
    }

    public function logsAction()
    {
        $this->_model = News::findRecordAll($this->_getParam('id_news'));
        $this->forward403Unless($this->_model);

        $data = array(
            'id_object' => $this->_model->getId(),
            'model' => get_class($this->_model),
            'order' => 'o.created_at DESC',
        );

        $logList = Log::getQuery($data);

        $this->view->logList = $this->_helper->paging($logList);
        $this->view->news = $this->_model;
    }

    protected function getHomePageAction()
    {
        $this->_navLeftDisplay = false;
        Base_Layout::setLayout('Admin', 'layout_empty');
    }

    public function saveMassAction($records = null, $params = null)
    {
        foreach($records as $id_news => $news) /* @var $news News */
        {
            if(isset($params[$id_news]))
            {
                $news->setIsActive($params[$id_news]['is_active']);
                $news->setArchivedAt($params[$id_news]['archived_at']);
                $news->setCommentsOn($params[$id_news]['comments_on']);

                $news->save();
            }
        }
    }

}