-- news_comment_status
CREATE TABLE IF NOT EXISTS `news_comment_status` (
  `id_news_comment_status` tinyint(2) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id_news_comment_status`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

INSERT INTO `news_comment_status` (`id_news_comment_status`, `name`) VALUES
(1, 'new'),
(2, 'active'),
(3, 'inactive');


-- news_comment
CREATE TABLE IF NOT EXISTS `news_comment` (
  `id_news_comment` int(11) NOT NULL AUTO_INCREMENT,
  `id_news` int(10) unsigned NOT NULL,
  `id_news_comment_status` tinyint(2) NOT NULL,
  `id_user` bigint(20) DEFAULT NULL,
  `nick` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `text` text NOT NULL,
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id_news_comment`),
  KEY `id_user` (`id_user`),
  KEY `id_news_comments_status` (`id_news_comment_status`),
  KEY `id_news` (`id_news`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

ALTER TABLE `news_comment`
  ADD CONSTRAINT `news_comment_ibfk_2` FOREIGN KEY (`id_news_comment_status`) REFERENCES `news_comment_status` (`id_news_comment_status`),
  ADD CONSTRAINT `news_comment_ibfk_1` FOREIGN KEY (`id_news`) REFERENCES `news` (`id_news`) ON DELETE CASCADE,
  ADD CONSTRAINT `news_comment_ibfk_3` FOREIGN KEY (`id_user`) REFERENCES `user` (`id_user`) ON DELETE SET NULL;


-- migration old data
INSERT INTO `news_comment`
(`id_news`, `text`, `id_user`, `nick`, `email`, `id_news_comment_status`, `created_at`)
SELECT `nc`.`id_news`, `nct`.`text`, NULL, `nc`.`author`, NULL, 2, `nc`.`created_at`
FROM `news_comments` AS `nc`
LEFT JOIN `news_comments_translation` AS `nct`
ON `nc`.`id_news_comments` = `nct`.`id_news_comments`;

-- exit drop
DROP TABLE `news_comments_translation`;
DROP TABLE `news_comments`;

ALTER TABLE `news` ADD `comments_on` BOOLEAN NOT NULL DEFAULT TRUE ;
