<?php
/**
 * Created by PhpStorm.
 * User: skotar
 * Date: 07.09.2014
 * Time: 10:51
 */

class News_Form_Admin_Filter_Comment extends Base_Form_Vertical {

    protected $_filter = true;

    public function init()
    {
        $this->setMethod('GET');
        $this->setAction('?page=1');
        $fields = array();
        $buttons = array();

        // username & nick
        $fields['author'] = $this->createElement('text', 'author', array(
            'label' => $this->_tlabel.'author'
        ));

        $fields['text'] = $this->createElement('text', 'text', array(
            'label' => $this->_tlabel.'text'
        ));

        $newsList = array('' => '') + News::getListArray();
        $fields['id_news'] = $this->createElement('select', 'id_news', array(
            'label' => $this->_tlabel.'id_news',
            'required' => false,
            'allowEmpty' => true,
            'filters' => array('StringTrim', 'Null'),
            'validators' => array(
                array('InArray', true, array(array_keys($newsList)))
            ),
            'multiOptions' => $newsList,
            'placeholder' => $this->getView()->translate('label_news_comment_form_news_empty'),
            'select2' => array(
                'allowClear' => true,
                'placeholder' => $this->getView()->translate('label_news_comment_form_news_empty')
            ),
        ));

        $statusList = array('' => '') + NewsCommentStatus::getListArray();
        $fields['id_news_comment_status'] = $this->createElement('select', 'id_news_comment_status', array(
            'label' => $this->_tlabel.'id_news_comment_status',
            'required' => false,
            'allowEmpty' => true,
            'filters' => array('StringTrim', 'Null'),
            'validators' => array(
                array('InArray', true, array(array_keys($statusList)))
            ),
            'multiOptions' => $statusList,
            'placeholder' => $this->getView()->translate('label_news_comment_form_status_empty'),
            'select2' => array(
                'allowClear' => true,
                'placeholder' => $this->getView()->translate('label_news_comment_form_status_empty')
            ),
        ));

        $buttons['clear'] = $this->createElement('clear', 'clear', array(
            'label' => 'cms_button_clear',
            'ignore' => true
        ));

        $buttons['submit'] = $this->createElement('submit', 'submit', array(
            'label' => 'cms_button_search',
            'type' => 'sbumit',
            'ignore' => true,
            'class' => 'btn-info'
        ));

        $buttons['clear']->removeDecorator('WrapElement');
        $buttons['submit']->removeDecorator('WrapElement');

        $this->addDisplayGroup(
            array_merge($fields, $buttons),
            'filter-search',
            array(
                'legend' => $this->_tlabel.'filter-search'
            )
        );

        $this->addHtmlTag( array( $fields['author'] ), array( 'class' => 'col-md-6' ) );
        $this->addHtmlTag( array( $fields['text'] ), array( 'class' => 'col-md-6' ) );
        $this->addHtmlTag( array( $fields['id_news'] ), array( 'class' => 'col-md-6' ) );
        $this->addHtmlTag( array( $fields['id_news_comment_status'] ), array( 'class' => 'col-md-3' ) );

        $this->addHtmlTag($buttons, array('class' => 'col-md-3 text-right', 'style' => 'margin-top: 20px;'));

        $this->addHtmlTag(array_merge($fields, $buttons), array('class' => 'row'));
    }
} 