<?php
/**
 * Created by JetBrains PhpStorm.
 * User: skotar
 * Date: 05.09.2013
 * Time: 18:44
 * To change this template use File | Settings | File Templates.
 */

class News_Form_Admin_Filter_News extends Base_Form_Vertical
{
    /**
     * @var bool
     */
    protected $_filter = true;

    /**
     * @var $_listData array
     */
    protected $_listData = array();

    protected $_sortCols = array(
        'title' => 't.title',
        'category_name' => 'nct.name',
        'archived_at' => 'o.archived_at',
        'is_active' => 'o.is_active',
        'comments_on' => 'o.comments_on',
    );

    protected $_avalibleCols = array(
        'id_news_image' => 'filter_news-column_id_news_image',
        'title' => 'filter_news-column_title',
        'category_name' => 'filter_news-column_category_name',
        'archived_at' => 'filter_news-column_archived_at',
        'comments_on' => 'filter_news-column_comments_on',
    );


    /**
     * @param $listData
     */
    protected function setListData($listData)
    {
        $this->_listData = $listData;
        $this->_idQuery = isset($listData['id_query']) ? $listData['id_query'] : array();

        if(!isset($this->_listData['filter']['column'])){
            $this->_listData['filter']['column'] = array('title', 'category_name', 'archived_at', 'comments_on');
        }
    }

    public function init()
    {
        $this->setMethod('get');
        $this->setAction('?page=1');
        $fields = array();
        $buttons = array();

        $fields['search'] = $this->createElement('text', 'search', array(
            'label' => $this->_tlabel.'title',
            'value' => isset($this->_listData['filter']['search']) && strlen($this->_listData['filter']['search']) > 0 ? $this->_listData['filter']['search'] : '',
        ));

        $categoryList = array('' => '') + NewsCategory::getListArray();
        $fields['id_news_category'] = $this->createElement('select', 'id_news_category', array(
            'label' => $this->_tlabel.'id_news_category',
            'required' => false,
            'allowEmpty' => true,
            'filters' => array('StringTrim', 'Null'),
            'validators' => array(
                array('InArray', true, array(array_keys($categoryList)))
            ),
            'multiOptions' => $categoryList,
            'placeholder' => $this->getView()->translate('label_news_form_news_category_empty'),
            'select2' => array(
                'allowClear' => true,
                'placeholder' => $this->getView()->translate('label_news_form_news_category_empty')
            ),
            'value' => isset($this->_listData['filter']['id_news_category']) && strlen($this->_listData['filter']['id_news_category']) > 0 ? $this->_listData['filter']['id_news_category'] : '',
        ));

        $options = array(
            '' => '',
            '0' => 'label_no',
            '1' => 'label_yes'
        );

        $optionsArchive = array(
            '' => '',
            0 => 'label_archive_all',
            1 => 'label_archive_only'
        );

        $fields['archived_at'] = $this->createElement('select', 'archived_at', array(
            'label' => $this->_tlabel.'archived_at',
            'multiOptions' => $optionsArchive,
            'value' => isset($this->_listData['filter']['archived_at']) && strlen($this->_listData['filter']['archived_at']) > 0 ? $this->_listData['filter']['archived_at'] : '',
        ));

        $fields['comments_on'] = $this->createElement('select', 'comments_on', array(
            'label' => $this->_tlabel.'comments_on',
            'multiOptions' => $options,
            'value' => isset($this->_listData['filter']['comments_on']) && strlen($this->_listData['filter']['comments_on']) > 0 ? $this->_listData['filter']['comments_on'] : '',
        ));

        $optionOrder = array('' => '');
        foreach($this->_sortCols as $name => $value){
            $optionOrder[$value] = $this->getView()->translate('label_news_admin_list_' . $name);
        }


        $fields['order'] = $this->createElement('select', 'order', array(
            'label' => $this->_tlabel.'order',
            'multiOptions' => $optionOrder,
            'validators' => array(
                array('InArray', true, array(array_keys($optionOrder)))
            ),
            'value' => isset($this->_listData['filter']['order']) && strlen($this->_listData['filter']['order']) > 0 ? $this->_listData['filter']['order'] : '',
        ));

        $optionOrderDirection = array(
            ''     => '',
            'ASC'  => $this->getView()->translate('label_order_direction_asc'),
            'DESC' => $this->getView()->translate('label_order_direction_desc'),
        );

        $fields['order_direction'] = $this->createElement('select', 'order_direction', array(
            'label' => $this->_tlabel.'order_direction',
            'multiOptions' => $optionOrderDirection,
            'value' => isset($this->_listData['filter']['order_direction']) && strlen($this->_listData['filter']['order_direction']) > 0 ? $this->_listData['filter']['order_direction'] : '',
        ));



        $columns['column'] = $this->createElement('multiselect', 'column', array(
            'multiOptions' => $this->_avalibleCols,
            'value' => $this->_listData['filter']['column'],
            'multiselectOrder' => true,
            'data-label-col-avalible' => $this->getView()->translate('label_multiselectOrder_col-avalible'),
            'data-label-col-selected' => $this->getView()->translate('label_multiselectOrder_col-selected'),
            'style' => 'height: 120px;',
            'validators' => array(
                array('InArray', true, array(array_keys($this->_avalibleCols)))
            ),
        ));


        $buttons['save_query'] = $this->createElement('html', 'save_query', array(
            'html' => "<a href='".Base::url('news_admin_save-query')."' class='btn btn-primary'>"
                . $this->getView()->translate('button_form_filter_save_query')
                . "</a>",
            'ignore' => true,
            'tag' => 'span',
            'class' => 'save_query'
        ));

        $buttons['clear'] = $this->createElement('clear', 'clear', array(
            'label' => 'cms_button_clear',
            'ignore' => true,
        ));

        $buttons['submit'] = $this->createElement('submit', 'submit', array(
            'label' => 'cms_button_search',
            'type' => 'submit',
            'ignore' => true,
            'class' => 'btn-info',
        ));

        $buttons['clear']->removeDecorator('WrapElement');
        $buttons['save_query']->removeDecorator('WrapElement');
        $buttons['submit']->removeDecorator('WrapElement');

        $this->addDisplayGroup(
            array_merge($fields, $columns, $buttons),
            'filter-search',
            array(
                'legend' => $this->_tlabel.'filter-search'
            )
        );



        $this->addHtmlTag(array( $fields['search'] ), array( 'class' => 'col-md-6' ) );
        $this->addHtmlTag(array( $fields['id_news_category'] ), array( 'class' => 'col-md-6' ) );
        $this->addHtmlTag(array($fields['search'], $fields['id_news_category']), array('class' => 'row'));


        $this->addHtmlTag( array( $fields['archived_at'] ), array( 'class' => 'col-md-6' ) );
        $this->addHtmlTag( array( $fields['comments_on'] ), array( 'class' => 'col-md-6' ) );
        $this->addHtmlTag( array( $fields['archived_at'], $fields['comments_on']), array('class' => 'row'));

        $this->addHtmlTag( array( $fields['order'] ), array( 'class' => 'col-md-6' ) );
        $this->addHtmlTag( array( $fields['order_direction'] ), array( 'class' => 'col-md-6' ) );
        $this->addHtmlTag( array( $fields['order'], $fields['order_direction']), array('class' => 'row'));

        $this->addHtmlTag( $fields, array( 'class' => 'col-md-6' ) );
        $this->addHtmlTag( $columns, array( 'class' => 'col-md-6' ) );

        $this->addHtmlTag(array_merge($fields, $columns), array('class' => 'row'));


        $this->addHtmlTag(array( $buttons['save_query'] ), array('class' => 'col-md-4'));
        $this->addHtmlTag(array( $buttons['clear'], $buttons['submit'] ), array('class' => 'col-md-8 text-right'));
        $this->addHtmlTag($buttons, array('class' => 'row'));
    }

    /**
     * @param bool $suppressArrayNotation
     * @return array
     */
    public function getValuesQuery($suppressArrayNotation = false)
    {

        $values = parent::getValuesQuery($suppressArrayNotation);

        if(isset($values['order']) && isset($values['order_direction'])){
            $values['order'] = trim($values['order'] . ' ' . $values['order_direction']);
            unset($values['order_direction']);
        }

        return $values;
    }



    public function populate(array $values)
    {
        $result = parent::populate($values);

        $options = array_flip($this->column->getValue());
        foreach($options as $k => $v){
            if(isset($this->_avalibleCols[$k])){
                $options[$k] = $this->_avalibleCols[$k];

            }
        }


        $options += array_diff_key($this->_avalibleCols, $options);

        $this->column->setMultiOptions($options);

        return $result;
    }



    public function getSortCols()
    {
        return $this->_sortCols;
    }

}