<?php
/**
 * Created by JetBrains PhpStorm.
 * User: skotar
 * Date: 16.08.2013
 * Time: 17:51
 * To change this template use File | Settings | File Templates.
 */

class News_Form_Admin_NewsCategory extends Base_Form_Horizontal {

    protected $_belong_to = "NewsFormAdminNewsCategory";
    protected $_tlabel = "form_news-category_admin_";

    /**
     * @var NewsCategory
     */
    protected $_model;

    public function init()
    {
        $fields = array();

        // Already Taken Param
        $vAlreadyTakenParams = array();
        if ( !$this->_model->isNew() ) {
            $vAlreadyTakenParams[] = array('id_news_category', '<>', $this->_model->getId());
        }

        $fields['name'] = $this->createElement('text', 'name', array(
            'label' => $this->_tlabel.'name',
            'allowEmpty' => false,
            'required' => true,
            'dimension' => 12,
            'filter' => array('StringTrim'),
            'validators' => array(
                array('NotEmpty', true),
                array('AlreadyTaken', true, array('NewsCategoryTranslation', 'name', $vAlreadyTakenParams))
            ),
            'value' => $this->_model->getName(),
        ));

        $fields['is_active'] = $this->createElement('checkbox', 'is_active', array(
            'label' => $this->_tlabel.'is_active',
            'value' => $this->_model->getIsActive(),
            'class' => 'iCheck',
        ));

        $fields['submit'] = $this->createElement('submit', 'submit', array(
            'label' => $this->_tlabel.'submit'
        ));

        $this->addDisplayGroup($fields, 'main', array(
            'legend' => $this->_tlabel.'group_std',
        ));

        $this->setAttrib('class', $this->getAttrib('class').' ajax');
        $this->setAttrib('id', $this->getElementsBelongTo());
        $this->setAttrib('data-replace', '#'.$this->getElementsBelongTo());
    }
}