<?php
/**
 * Created by PhpStorm.
 * User: skotar
 * Date: 09.09.2014
 * Time: 09:27
 */

class News_Form_Comment extends Base_Form_Horizontal {

    public function init()
    {
        $fields = array();

        if(!Base_Auth::getUser())
        {
            $fields['nick'] = $this->createElement('text', 'nick', array(
                'allowEmpty' => false,
                'required' => true,
                'filters' => array('StringTrim'),
                'validators' => array(
                    array('NotEmpty', true),
                    array('StringLength', true, array('min' => 3, 'max' => 255))
                ),
                'placeholder' => $this->getView()->translate($this->_tlabel.'nick'),
                'size' => 12
            ));

            $fields['email'] = $this->createElement('text', 'email', array(
                'allowEmpty' => false,
                'required' => true,
                'filters' => array('StringTrim'),
                'validators' => array(
                    array('NotEmpty', true),
                    array('EmailAddress', true)
                ),
                'placeholder' => $this->getView()->translate($this->_tlabel.'email'),
                'size' => 12
            ));


            $this->addHtmlTag( array( $fields['nick'] ), array('class' => 'col-md-6') );
            $this->addHtmlTag( array( $fields['email'] ), array('class' => 'col-md-6') );
            $this->addHtmlTag(array_merge(array( $fields['nick'] ), array( $fields['email'] )), array('class' => 'row') );
        }

        $fields['text'] = $this->createElement('textarea', 'text', array(
            'allowEmpty' => false,
            'required' => true,
            'filters' => array('StringTrim'),
            'validators' => array(
                array('NotEmpty', true)
            ),
            'rows' => 6,
            'size' => 12,
            'placeholder' => $this->getView()->translate($this->_tlabel.'text'),
        ));

        $fields['submit'] = $this->createElement('submit', 'submit', array(
            'label' => $this->_tlabel.'submit',
            'class' => 'pull-right',
            'buttonType' => Base_Form_Element_Submit::BUTTON_PRIMARY
        ));

        $this->addDisplayGroup(
            $fields,
            'main',
            array(
                'legend' => $this->_tlabel.'group_std'
            )
        );

        $group = $this->getDisplayGroup('main');
        $group->removeDecorator('body');
        $group->removeDecorator('Panel');
        $group->removeDecorator('box');
    }
} 