<?php
// Connection Component Binding
Doctrine_Manager::getInstance()->bindComponent('News', 'base');

/**
 * Table_News
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 * 
 * @property integer $id_news
 * @property integer $id_news_image
 * @property integer $id_news_category
 * @property timestamp $created_at
 * @property timestamp $publication_start
 * @property timestamp $publication_end
 * @property timestamp $archived_at
 * @property boolean $comments_on
 * 
 * @method integer getId()
 * @method boolean isNew()
 * @static News find($id, $id_language = null, $tableName = null)
 * @static News findOneBy*
 * @static Doctrine_Collection findBy*
 * @method getTransaltion() getTransaltion($id_language)
 * 
 * @method getIdNews() getIdNews($id_language = null)
 * @method setIdNews() setIdNews($value, $id_language = null)
 * @method getIdNewsImage() getIdNewsImage($id_language = null)
 * @method setIdNewsImage() setIdNewsImage($value, $id_language = null)
 * @method getIdNewsCategory() getIdNewsCategory($id_language = null)
 * @method setIdNewsCategory() setIdNewsCategory($value, $id_language = null)
 * @method getCreatedAt() getCreatedAt($id_language = null)
 * @method setCreatedAt() setCreatedAt($value, $id_language = null)
 * @method getPublicationStart() getPublicationStart($id_language = null)
 * @method setPublicationStart() setPublicationStart($value, $id_language = null)
 * @method getPublicationEnd() getPublicationEnd($id_language = null)
 * @method setPublicationEnd() setPublicationEnd($value, $id_language = null)
 * @method getArchivedAt() getArchivedAt($id_language = null)
 * @method setArchivedAt() setArchivedAt($value, $id_language = null)
 * @method getCommentsOn() getCommentsOn($id_language = null)
 * @method setCommentsOn() setCommentsOn($value, $id_language = null)
 * @method getTitle() getTitle($id_language = null)
 * @method setTitle() setTitle($value, $id_language = null)
 * @method getLead() getLead($id_language = null)
 * @method setLead() setLead($value, $id_language = null)
 * @method getText() getText($id_language = null)
 * @method setText() setText($value, $id_language = null)
 * @method getMetaTitle() getMetaTitle($id_language = null)
 * @method setMetaTitle() setMetaTitle($value, $id_language = null)
 * @method getMetaKeywords() getMetaKeywords($id_language = null)
 * @method setMetaKeywords() setMetaKeywords($value, $id_language = null)
 * @method getMetaDescription() getMetaDescription($id_language = null)
 * @method setMetaDescription() setMetaDescription($value, $id_language = null)
 * 
 * @property Image $NewsImage
 * @property NewsCategory $NewsCategory
 * @property Doctrine_Collection $Translations
 * @property Doctrine_Collection $NewsComment
 * 
 * @package    ##PACKAGE##
 * @subpackage ##SUBPACKAGE##
 * @author     ##NAME## <##EMAIL##>
 * @version    SVN: $Id: Builder.php 7490 2010-03-29 19:53:27Z jwage $
 */
abstract class Table_News extends Base_Doctrine_Record
{
    public function setTableDefinition()
    {
        $this->setTableName('news');
        $this->hasColumn('id_news', 'integer', null, array(
             'type' => 'integer',
             'primary' => true,
             'autoincrement' => true,
             ));
        $this->hasColumn('id_news_image', 'integer', null, array(
             'type' => 'integer',
             'notnull' => false,
             ));
        $this->hasColumn('id_news_category', 'integer', null, array(
             'type' => 'integer',
             ));
        $this->hasColumn('created_at', 'timestamp', null, array(
             'type' => 'timestamp',
             'notnull' => true,
             ));
        $this->hasColumn('publication_start', 'timestamp', null, array(
             'type' => 'timestamp',
             'notnull' => false,
             ));
        $this->hasColumn('publication_end', 'timestamp', null, array(
             'type' => 'timestamp',
             'notnull' => false,
             ));
        $this->hasColumn('archived_at', 'timestamp', null, array(
             'type' => 'timestamp',
             ));
        $this->hasColumn('comments_on', 'boolean', null, array(
             'type' => 'boolean',
             'default' => true,
             ));

        $this->option('select', 'o.*, t.title as title, t.lead as lead, t.text as text');
        $this->option('search', 't.title');
        $this->option('log', true);
    }

    public function setUp()
    {
        parent::setUp();
        $this->hasOne('Image as NewsImage', array(
             'local' => 'id_news_image',
             'foreign' => 'id_image',
             'onDelete' => 'SET NULL'));

        $this->hasOne('NewsCategory', array(
             'local' => 'id_news_category',
             'foreign' => 'id_news_category',
             'onDelete' => 'CASCADE'));

        $this->hasMany('NewsTranslation as Translations', array(
             'local' => 'id_news',
             'foreign' => 'id_news'));

        $this->hasMany('NewsComment', array(
             'local' => 'id_news',
             'foreign' => 'id_news'));
    }
}