<?php
/**
 * Created by JetBrains PhpStorm.
 * User: Robert
 * Date: 18.05.13
 * Time: 10:51
 * To change this template use File | Settings | File Templates.
 */

class News_Widget_LastNews extends Base_Widget_Abstract{


    public $name = 'label_news_widget_last_news_list';


    public function getViewScriptsDir()
    {
        return __DIR__;
    }

    public function getRenderView()
    {
        return 'last-news.phtml';
    }

    public function configureForm()
    {
        $fields = array();

        $fields['title'] = $this->view->form->createElement('text', 'title', array(
            'label' => 'form-label_news-widget-last-news_title',
            'class' => 'span12',
            'allowEmpty' => false,
            'required' => true,
            'filters' => array('StringTrim'),
        ));

        $fields['limit'] = $this->view->form->createElement('text', 'limit', array(
            'label' => 'form-label_news-widget-last-news_limit',
            'class' => 'span12',
            'filters' => array('StringTrim'),
        ));

        $this->view->form->addElements($fields);
    }

    public function renderWidget()
    {
        $this->params['title'] = isset($this->params['title']) && !empty($this->params['title']) ? $this->params['title'] : $this->view->translate('label_last_news');

        $query = News::getQuery();
        $query->addWhere('(o.publication_start IS NULL OR o.publication_start <= NOW())')
            ->addWhere('(o.publication_end IS NULL OR o.publication_end >= NOW()')
            ->orderBy('o.publication_start DESC, o.created_at DESC')
            ->limit(4);

        $this->view->newsList = $query->execute(array(), Doctrine::HYDRATE_ARRAY);
    }
}