<?php

class Page_AdminController extends Base_Controller_Action_Cms
{
    /**
     * @var $_model Page
     */
    private $_model;

    protected $_route_return = 'page_admin_edit';

    protected function _getReturnParams()
    {
        return array('id_page' => $this->_model->getId());
    }

    public function indexAction()
    {
        $this->_mode = $this->getParam('mode');
        if($this->_mode == 'get'){
            $this->_navLeftDisplay = false;
            Base_Layout::setLayout('Admin', 'layout_empty');
        }

        if ($this->getParam('id_page') ) {
            $this->_model = Page::findRecordAll($this->getParam('id_page'));
        }

        $data = array('is_active' => '', 'translations_leftJoin' => true);
        $query = Page::getQuery($data);

        $this->view->Page = $this->_model;
        $this->view->pageList = $this->_helper->paging($query);
        $this->view->mode = $this->_mode;
    }

    public function newAction()
    {
        $this->_model = new Page();
        $this->_model->setDataMapModule('Page');
        $this->_model->setDataMapLayout('layout');

        $this->_form($this->_model, 'Page_Form_Admin_Page');
        $this->view->page = $this->_model;
    }

    public function editAction()
    {
        $this->_model = Page::findRecordAll($this->getParam('id_page'));
        $this->forward403Unless($this->_model);

        $this->_form($this->_model, 'Page_Form_Admin_Page');
        $this->view->page = $this->_model;
    }


    public function deleteAction()
    {
        $this->_model = Page::findRecordAll( $this->getParam('id_page') );
        $this->forward404Unless($this->_model);

        $this->_model->delete();

        $this->_flash()->success->addMessage('label_page_admin_delete_msg-ok');
        $this->_redirector()->gotoRouteAndExit(array(), 'page_admin');
    }


    public function getPageLayoutAction()
    {
        $layout = explode('-', $this->getParam('layout'));
        $module = array_shift($layout);
        $layout = trim(join('-', $layout), '-');
        $placeholders = array();

        if ( $this->hasParam('id_page') ) {
            $this->_model = Page::findRecordAll($this->getParam('id_page'));
            if ( $this->_model )
            {
                $this->_model->setDataMapLayout($layout);
                $this->_model->setDataMapModule($module);
                $placeholders = $this->_model->getDataMapPlaceholders();
            }
        }

        $html = '';
        if ( !Base_Layout::layoutIsRegistred($module, $layout) ) {
            $html.= '<div class="alert alert-danger">'.$this->view->translate('error_selected-layout_is-not-registred').'</div>';
        } else {
            $html.= $this->view->formPageDataMap( 'data_map', $placeholders, array(
                'module' => $module,
                'layout' => $layout,
                'placeholders' => $placeholders,
            ));
        }

        $this->_helper->json( array(
            'result' => true,
            'layout' => $layout,
            'html' => $html,
        ));

    }



}
