<?php

class Page_IndexController extends Base_Controller_Action_Frontend
{
    /**
     * @var Page
     */
    private $_page;

    public function indexAction()
    {
        $this->_page = Page::findRecord($this->getParam('id_page'));
        $this->forward403Unless($this->_page);

        if(($metaTitle = $this->_page->getMetaTitle()) !== ''){ $this->view->headTitle($metaTitle); }
        if(($metaDescription = $this->_page->getMetaDescription()) != ''){ $this->view->headMeta()->setName('description',$this->view->escape($metaDescription)); }
        if(($metaKeywords = $this->_page->getMetaKeywords()) != ''){ $this->view->headMeta()->setName('keywords',$this->view->escape($metaKeywords)); }

        $module = $this->_page->getDataMapModule();
        $layout = $this->_page->getDataMapLayout();

        Base_Layout::setLayout($module, $layout);
        Base_Layout::setLayoutDefinitions($this->_page->getDataMapPlaceholders());

        $this->view->page = $this->_page;
    }
}