<?php
$router = Zend_Controller_Front::getInstance()->getRouter();

$router->addRoute('page', new Zend_Controller_Router_Route(
    '/page/:id_page',
    array(
        'module' => 'page',
        'controller' => 'index',
        'action' => 'index',
        'id_page' => null,
    ),
    array(
        'id_page' => '\d+'
    )
));

// home page
$idPageHome = Doctrine_Query::create()
    ->select('id_page')
    ->from('Page')
    ->addWhere('is_active = 1')
    ->addWhere('is_home_page = 1')
    ->fetchOne(array(), Doctrine::HYDRATE_SINGLE_SCALAR);

if($idPageHome){
    $router->addRoute('home', new Zend_Controller_Router_Route(
        '/',
        array(
            'module' => 'page',
            'controller' => 'index',
            'action' => 'index',
            'id_page' => $idPageHome,
        )
    ));
}

// pages from uri
$pages = Doctrine_Query::create()
    ->select('o.id_page, t.id_language as id_language, t.title as title, t.uri as uri')
    ->from('Page o INDEXBY o.id_page')
    ->leftJoin('o.Translations t WITH t.id_language = ?', Base_I18n::getLangId())
    ->where('t.uri != ""')
    ->addWhere('o.is_active = 1')
    ->addWhere('o.is_home_page != 1')
    ->fetchArray();

foreach($pages as $page){
    $router->addRoute('page_'.$page['uri'], new Zend_Controller_Router_Route(
        '/'.$page['uri'],
        array(
            'module' => 'page',
            'controller' => 'index',
            'action' => 'index',
            'id_page' => $page['id_page']
        )
    ));
}

Zend_Controller_Front::getInstance()->setRouter($router);


