<?php

class TextPage_IndexController extends Base_Controller_Action_Frontend
{

    /**
     * @var TextPage
     */
    private $_textPage;

    public function init()
    {
        parent::init();

        $this->_textPage = TextPage::findRecord($this->getParam('id_text_page'));
        $this->forward403Unless($this->_textPage);

        if($this->_textPage->id_text_page_parent == 3){
            Base_Layout::prependWidget(array('_class' => 'TextPage_Widget_Nav', 'id_text_page' => 3, 'title' => 'Dokumentacja', 'fix' => true), 'left');
        }
    }

    public function indexAction()
    {
        $this->_textPage = TextPage::findRecord($this->getParam('id_text_page'));
        $this->forward403Unless($this->_textPage);

        if(strlen($metaTitle = $this->_textPage->getMetaTitle())){ $this->view->headTitle($metaTitle); }
        if(strlen($metaDescription = $this->_textPage->getMetaDescription())){ $this->view->headMeta()->setName('description',$this->view->escape($metaDescription)); }
        if(strlen($metaKeywords = $this->_textPage->getMetaKeywords())){ $this->view->headMeta()->setName('keywords',$this->view->escape($metaKeywords)); }

        $this->view->textPage = $this->_textPage;
    }

}
