<?php
/**
 * Created by JetBrains PhpStorm.
 * User: Robert
 * Date: 18.05.13
 * Time: 10:51
 * To change this template use File | Settings | File Templates.
 */

class TextPage_Widget_Nav extends Base_Widget_Abstract
{
    public $name = 'label_text_page_widget_navigation';

    public function getViewScriptsDir()
    {
        return __DIR__;
    }

    public function getRenderView()
    {
        return 'nav.phtml';
    }

    public function configureForm()
    {
        $fields = array();

        $fields['title'] = $this->view->form->createElement('text', 'title', array(
            'label' => 'form-label_text-page-widget-nav_title',
            'class' => 'span12',
            'required' => true,
            'allowEmpty' => false,
            'filters' => array('StringTrim'),
        ));

        $fields['id_text_page'] = $this->view->form->createElement('text', 'id_text_page', array(
            'label' => 'form-label_news-widget-last-news_id_text_page',
            'class' => 'span12',
            'filters' => array('StringTrim'),
        ));

        $fields['fix'] = $this->view->form->createElement('checkbox', 'fix', array(
            'label' => 'form-label_news-widget-last-news_fix',
        ));

        $this->view->form->addElements($fields);
    }


    public function renderWidget()
    {
        $id_text_page = $this->params['id_text_page'];
        $this->params['fix'] = isset($this->params['fix']) ? $this->params['fix'] : false;

        $textPageQuery = Doctrine_Query::create()
            ->from('TextPage tp0')
            ->innerJoin('tp0.Translations t0 INDEXBY t0.id_language')
            ->leftJoin('tp0.Pages tp1')
            ->leftJoin('tp1.Translations t1 WITH t1.id_language = ? INDEXBY t1.id_language', Base_I18n::getLangId())
            ->where('t0.id_language = ?', Base_I18n::getLangId());

        if(!empty($id_text_page)){
            $textPageQuery->addWhere('tp0.id_text_page_parent = ?', $id_text_page);
        }else{
            $textPageQuery->addWhere('tp0.id_text_page_parent IS NULL');
        }

        $textPageList = $textPageQuery->execute(array(), Doctrine::HYDRATE_ARRAY);

        $pages = array();
        foreach($textPageList as $tp0){
            $page = array();
            $page['label'] = $tp0['Translations'][Base_I18n::getLangId()]['title'];
            $page['resource'] = 'text-page_index_index';

            $uri0 = $tp0['Translations'][Base_I18n::getLangId()]['uri'];
            if(!empty($uri0)){
                $page['route'] = 'text-page_'.$uri0;
            }else{
                $page['route'] = 'text-page';
                $page['params'] = array('id_text_page' => $tp0['id_text_page']);
            }

            $page['pages'] = array();
            foreach($tp0['Pages'] as $tp1){
                $page1 = array();
                $page1['label'] = $tp1['Translations'][Base_I18n::getLangId()]['title'];
                $page1['resource'] = 'text-page_index_index';

                $uri1 = $tp1['Translations'][Base_I18n::getLangId()]['uri'];
                if(!empty($uri1)){
                    $page1['route'] = 'text-page_'.$uri1;
                }else{
                    $page1['route'] = 'text-page';
                    $page1['params'] = array('id_text_page' => $tp1['id_text_page']);
                }

                $page['pages'][] = $page1;
            }

            $pages[] = $page;
        }

        $container = new Zend_Navigation();
        $container->addPages($pages);

        $this->view->container = $container;
    }


}