<?php
/**
 * Created by JetBrains PhpStorm.
 * User: Marek Skotarek
 * Date: 29.06.2013
 * Time: 18:17
 * To change this template use File | Settings | File Templates.
 */

class User_AccountController extends Base_Controller_Action_Frontend {

    /**
     * @var User
     */
    private $_user;

    /**
     * @var UserEmail
     */
    private $_userEmail;

    /**
     * @var User_Form_Account
     */
    private $_formAccount;

    /**
     * @var User_Form_ChangePass
     */
    private $_formChangePass;

    /**
     * @var User_Form_ManageEmails
     */
    private $_formManageEmails;

    /**
     * @var User_Form_AddNewEmail
     */
    private $_formAddNewEmail;

    public function init()
    {
        parent::init();
        Base_Layout::prependWidget(array('_class' => 'Navigation_Widget_Nav', 'id_navigation' => 4, 'title' => 'Menu użytkownika', 'renderView' => 'nav-left.phtml'), 'left');
    }

    public function preDispatch()
    {
        parent::preDispatch();
        Navigation_Breadcrumb::_()->add(array(
            'url' => Base::url('user_account_edit-profile'),
            'title' => $this->view->translate('breadcrumb_user-account'),
        ));
    }


    public function editProfileAction()
    {
        // get user
        $this->_user = User::findRecordAll(Base_Auth::getUser('id_user'));

        $this->_formAccount = new User_Form_Account(array('model' => $this->_user));
        if ($this->_request->isPost() && $this->_formAccount->isValid($this->_request->getPost())) {
            $this->_user->save();
            $this->_flash()->success->addMessage('message_user_edit-profile_success');
            $this->_redirector()->gotoRouteAndExit();
        }

        $this->view->form = $this->_formAccount;
    }

    public function changePassAction()
    {
        // get user
        $this->_user = User::findRecordAll(Base_Auth::getUser('id_user'));

        $this->_formChangePass = new User_Form_ChangePass(array('model' => $this->_user));
        if ( $this->_request->isPost() && $this->_formChangePass->isValid( $this->_request->getPost() ) ) {
            $this->_user->save();
            $this->_flash()->success->addMessage('message_user_change-pass_success');
            $this->_redirector()->gotoRouteAndExit();
        }

        $this->view->form = $this->_formChangePass;
        Navigation_Breadcrumb::_()->add(array(
            'url' => Base::url(),
            'title' => $this->view->translate('breadcrumb_user-account_change-pass'),
        ));
    }

    public function manageEmailsAction()
    {
        // new user email
        $this->_userEmail = new UserEmail();
        $this->_userEmail->setIdUser(Base_Auth::getUser('id_user'));
        $this->_userEmail->setIsActive(false);
        $this->_userEmail->setIsMain(false);

        // form to add new email
        $this->_formAddNewEmail = new User_Form_AddNewEmail( array('model' => $this->_userEmail) );
        if ($this->_request->isPost() && $this->hasParam($this->_formAddNewEmail->getElementsBelongTo())
            && $this->_formAddNewEmail->isValid( $this->_request->getPost() ) )
        {
            $data = $this->_formAddNewEmail->getValues($this->_formAddNewEmail->getElementsBelongTo());
            $this->_sendConfirmNewEmail($data['email']);
            $this->_flash()->success->addMessage('msg_user-account_add-new-email');
            $this->_flash()->info->addMessage('msg_user-account_confirm-new-email');
            $this->_redirector()->gotoRouteAndExit();
        }

        // form to change main email
        $this->_formManageEmails = new User_Form_ManageEmails();
        if ($this->_request->isPost() && $this->hasParam($this->_formManageEmails->getElementsBelongTo())
            && $this->_formManageEmails->isValid( $this->_request->getPost() ) )
        {
            $this->_flash()->success->addMessage('msg_user-account_main-email-change');
            $this->_redirector()->gotoRouteAndExit();
        }

        $this->view->formManageEmails = $this->_formManageEmails;
        $this->view->formAddNewEmail = $this->_formAddNewEmail;
        Navigation_Breadcrumb::_()->add(array(
            'url' => Base::url(),
            'title' => $this->view->translate('breadcrumb_user-account_menage-emails'),
        ));
    }

    private function _sendConfirmNewEmail($email)
    {
        // get user
        $this->_user = User::findRecordAll($this->_userEmail->getIdUser());

        $userConfirmRequest = new UserConfirmRequest();
        $userConfirmRequest->User = $this->_user;
        $userConfirmRequest->setHash(Base::getHash());
        $userConfirmRequest->setType(UserConfirmRequest::TYPE_NEW_EMAIL);
        $userConfirmRequest->setChannel(get_class($this->_user));
        $userConfirmRequest->setObjectId($this->_user->getId());
        $userConfirmRequest->save();

        $this->view->user = $this->_user;
        $this->view->userEmail = $this->_userEmail;
        $this->view->userConfirmRequest = $userConfirmRequest;

        $mail = new Base_Mail();
        $mail->setBodyContent('account/_mail_new_email.phtml');
        $mail->setSubject($this->view->translate('mail_user_account_new_mail_subject'));
        $mail->addTo($email);
        $mail->send();
    }

    public function confirmNewEmailAction()
    {
        $userConfirmRequest = UserConfirmRequest::findOneByHash( $this->_getParam('hash') );
        $newEmail = $this->_getParam('email');
        $message = null;
        $result = null;

        if ( !$userConfirmRequest ) {
            $result = 'error';
            $message = 'message_user_account_confirm-new-email_activate-error';
        } else {
            $this->_userEmail = UserEmail::findOneByEmail($newEmail);
            $isActive = (bool) $userConfirmRequest->is_active;

            if ( !$isActive ) {
                $message = 'message_user_register_confirm-activate_info-link-expired';
                $result = 'info';
            } else {
                if ( $this->_userEmail && $this->_userEmail->getIdUser() == Base_Auth::getUser('id_user') ) {
                    $userConfirmRequest->setUsedAt(date('YmdHis'));
                    $userConfirmRequest->save();

                    $this->_userEmail->setIsActive(true);
                    $this->_userEmail->save();

                    $result = 'success';
                    $message = 'message_user_account_confirm-new-email_activate-success';
                }
            }
        }
        $this->view->result = $result;
        $this->view->message = $message;
    }
}