<?php

/**
 * Created by PhpStorm.
 * User: Dawid Przygodzki
 * Date: 2015-08-11
 * Time: 14:57
 */
class User_AdminCompanyController extends Base_Controller_Action_Cms
{
    /**
     * @var User
     */
    private $_user = null;

    /**
     * @var Company_Form_Admin_UserCompany
     */
    private $_formUserCompany;

    /**
     * @var Company_Form_Admin_UserCompanyList
     */
    private $_formUserCompanyList;

    public function init()
    {
        parent::init();

        $this->_user = User::findRecordAll($this->getParam('id_user'));
        $this->forward403Unless($this->_user);

        if(!Setting::getSetting('user.manage_company')){
            $this->_redirector()->gotoRouteAndExit(array('id_user' => $this->_user->getId()), 'user_admin_edit');
        }
    }

    public function indexAction()
    {
        $this->_formUserCompanyList();
        $this->_formUserCompany();

        $this->view->placeholder( 'page-title' )->set( $this->view->translate('cms-page-title_user_company') . ': ' . $this->_user->name . ' ' . $this->_user->surname);
        $this->view->user = $this->_user;
    }

    private function _formUserCompanyList()
    {
        if(!class_exists('CompanyHasUser')) return ;

        $this->_formUserCompanyList = new Company_Form_Admin_UserCompanyList(array('model' => $this->_user));
        $this->view->formUserCompanyList = $this->_formUserCompanyList;

        if($this->_request->isPost() &&
            $this->hasParam($this->_formUserCompanyList->getElementsBelongTo()) &&
            $this->_formUserCompanyList->isValid($this->_request->getPost())
        ){
            $this->_user->save();
            $this->_flash()->success->addMessage('label_cms_save_success');
            $this->_redirector()->gotoRouteAndExit(array('id_user' => $this->_user->getId()), 'user_admin_company_index');
        }
    }

    private function _formUserCompany()
    {
        if(!class_exists('CompanyHasUser')) return ;

        $this->_modelCompanyHasUser = new CompanyHasUser();
        $this->_modelCompanyHasUser->setIdUser($this->_user->getId());

        $this->_formUserCompany = new Company_Form_Admin_UserCompany(array('model' => $this->_modelCompanyHasUser));
        $this->view->formUserCompany = $this->_formUserCompany;

        if($this->_request->isPost() &&
            $this->hasParam($this->_formUserCompany->getElementsBelongTo()) &&
            $this->_formUserCompany->isValid($this->_request->getPost())
        )
        {
            $this->_modelCompanyHasUser->save();
            $this->_user->save();
            $this->_flash()->success->addMessage('label_cms_save_success');
            $this->_redirector()->gotoRouteAndExit(array('id_user' => $this->_user->getId()), 'user_admin_company_index');
        }
    }
}