<?php

/**
 * Created by PhpStorm.
 * User: Dawid Przygodzki
 * Date: 2015-07-20
 * Time: 11:51
 */
class User_AdminDashboardController extends Base_Controller_Action_Cms
{
    /**
     * @var $_model UserDashboard
     */
    private $_model = null;

    /**
     * @var $_model User
     */
    private $_user = null;

    public function init()
    {
        parent::init();

        if(!Setting::getSetting('user.edit_dashboard_on')){
            $this->_redirector()->gotoRouteAndExit(array(), 'admin');
        }
    }

    public function editAction()
    {
        $this->_model = UserDashboard::preparedModel();

        $this->_form($this->_model, 'User_Form_Admin_Dashboard');

        $dashboardExist = (bool) UserDashboard::findOneByIdUser(Base_Auth::getUserId());

        $this->_helper->viewRenderer('admin-dashboard/form');
        $this->view->userDashboard = $this->_model;
        $this->view->dashboardExist = $dashboardExist;
    }

    public function deleteAction()
    {
        $this->_model = UserDashboard::findRecordAll(Base_Auth::getUserId());
        $this->forward403Unless($this->_model);

        $this->_model->delete();

        $this->_flash()->success->addMessage('label_cms_restored_to_default_status');
        $this->_redirector()->gotoRouteAndExit(array(), 'user_admin_dashboard_edit');
    }

    public function getUserLayoutAction()
    {
        $layout = explode('-', $this->getParam('layout'));
        $module = array_shift($layout);
        $layout = trim(join('-', $layout), '-');

        $this->_model = UserDashboard::preparedModel();
        $placeholders = $this->_model->getDataMapPlaceholders();

        $html = '';
        if ( !Base_Layout::layoutIsRegistred($module, $layout) ) {
            $html.= '<div class="alert alert-danger">'.$this->view->translate('error_selected-layout_is-not-registred').'</div>';
        } else {
            $html.= $this->view->formUserDataMap( 'data_map', $placeholders, array(
                'module' => $module,
                'layout' => $layout,
                'placeholders' => $placeholders,
            ));
        }

        $this->_helper->json( array(
            'result' => true,
            'layout' => $layout,
            'html' => $html,
        ));
    }
}