<?php
/**
 * Created by JetBrains PhpStorm.
 * User: Marek Skotarek
 * Date: 29.06.2013
 * Time: 18:38
 * To change this template use File | Settings | File Templates.
 */

class User_Form_Account extends Base_Form_Horizontal {

    protected $_belong_to = "UserFormAccount";

    protected $_tlabel = "user_form_account_";

    /**
     * @var User
     */
    protected $_model;

    public function init()
    {
        $fields = array();
        $fields['name'] = $this->createElement('text', 'name', array(
            'label' => $this->_tlabel.'name',
            'allowEmpty' => false,
            'required' => true,
            'filters' => array('StringTrim'),
            'validators' => array(
                array('NotEmpty', true)
            ),
            'value' => $this->_model->getName(),
        ));

        $fields['surname'] = $this->createElement('text', 'surname', array(
            'label' => $this->_tlabel.'surname',
            'allowEmpty' => false,
            'required' => true,
            'filters' => array('StringTrim'),
            'validators' => array(
                array('NotEmpty', true)
            ),
            'value' => $this->_model->getSurname(),
        ));

        $fields['id_profile_image'] = $this->createElement('FileImage', 'id_profile_image', array(
            'label' => $this->_tlabel.'id_profile_image',
            'allowEmpty' => false,
            'validators' => array(
                array('Extension', false, 'jpg, png, gif'),
                array('Count', false, 1),
            ),
            'filestyle' => array(
                'buttonText' => $this->getView()->translate('button_browse_file'),
                'size' => 'sm',
                'buttonName' => 'btn-primary',
                'buttonBefore' => true,
            ),
        ));

        if(!empty( $this->_model->id_profile_image )) {
            $imageDecorator = $fields['id_profile_image']->getDecorator('FileImage');
            $imageDecorator->setOptions( array(
                'id_image' => $this->_model->id_profile_image,
                'crop' => true,
                'delete' => true,
            ) );
        }

        $fields['submit'] = $this->createElement('submit', 'submit', array(
            'label' => $this->_tlabel.'submit',
            'class' => 'pull-right',
        ));

        $this->addDisplayGroup(
            $fields,
            'main',
            array(
//                'legend' => $this->_tlabel.'group_user_info',
            )
        );

        $g = $this->getDisplayGroup('main');
        $g->removeDecorator('panel');
    }

}