<?php
/**
 * Created by JetBrains PhpStorm.
 * User: Marek Skotarek
 * Date: 12.07.2013
 * Time: 20:34
 * To change this template use File | Settings | File Templates.
 */

class User_Form_AddNewEmail extends Base_Form_Horizontal {

    protected $_belong_to = "UserFormAddNewEmail";
    protected $_tlabel = "user_form_add_new_email_";

    /**
     * @var UserEmail
     */
    protected $_model;

    protected function setModel( $model ) {
        $this->_model = $model;
    }

    public function init()
    {
        $fields = array();

        $newEmailValidator = new User_Validate_NewEmail(array('model' => 'UserEmail', 'column' => 'email') );

        $fields['email'] = $this->createElement('text', 'email', array(
            'label' => $this->_tlabel.'newEmail',
            'allowEmpty' => false,
            'required' => true,
            'filters' => array('StringTrim'),
            'validators' => array(
                array('NotEmpty', true),
                array($newEmailValidator, true),
            ),
            'size' => 9,
            'label-size' => 3
        ));

        $fields['submit'] = $this->createElement('submit', 'submit', array(
            'label' => $this->_tlabel.'submit',
            'size' => 9,
            'offset' => 3
        ));

        $this->addDisplayGroup(
            $fields,
            'main',
            array(
            )
        );

        $g = $this->getDisplayGroup('main');
        $g->removeDecorator('panel');
    }

    public function postIsValid( $data )
    {
        $data = $this->getValues( $this->_belong_to );
        $issetEmail = UserEmail::findOneByEmail($data['email']);
        if ( !$issetEmail ) {
            $this->_model->setEmail($data['email']);
            $this->_model->save();
        }
        return true;
    }
}