<?php

class User_Form_Admin_AddEmail extends Base_Form_Horizontal
{

    /**
     * @var User
     */
    protected $_model;

    public function init()
    {
        $fields = array();

        $fields['email'] = $this->createElement('text', 'email', array(
            'label' => $this->_tlabel.'email',
            'required' => true,
            'allowEmpty' => false,
            'filters' => array('StringTrim'),
            'validators' => array(
                array('StringLength', true, array('max' => 255)),
                array('NotEmpty', true),
                array('EmailAddress', true),
                array( 'AlreadyTaken', true, array('model' => 'UserEmail', 'column' => 'email')),
            ),
            'size' => 9, 'label-size' => 3,
        ));

        $fields['submit'] = $this->createElement('submit', 'submit', array(
            'label' => $this->_tlabel.'submit',
            'offset' => 3,
            'size' => 9,
        ));

        $this->addDisplayGroup($fields, 'main', array(
            'legend' => $this->_tlabel.'group_info',
            'class' => 'panel-primary'
        ));
    }

    public function postIsValid($data)
    {
        $email = new UserEmail();
        $email->email = $this->getValue('email');
        $email->is_active = true;
        $email->User = $this->_model;
        $email->save();

        return true;
    }

}