<?php

/**
 * Created by PhpStorm.
 * User: Dawid Przygodzki
 * Date: 2015-07-20
 * Time: 12:01
 */
class User_Form_Admin_Dashboard extends Base_Form_Horizontal
{
    /**
     * @var UserDashboard
     */
    protected $_model;

    public function init()
    {
        $fields = array();

        $layoutsList = Layout::getQuery(array('is_dashboard' => 1))->execute();

        $layoutOptions = array();
        foreach ($layoutsList as $layout){
            $ret = Base_Layout::getLayoutCmsNames($layout['module'], 'all');
            if(!empty($ret)){
                $layoutOptions[$layout['module']] = $ret;
            }
        }

        $fields['layout'] = $this->createElement( 'select', 'layout', array(
            'label' => $this->_tlabel.'layout',
            'required' => true,
            'allowEmpty' => false,
            'filters' => array('StringTrim'),
            'multioptions' => $layoutOptions,
            'value' => $this->_model->getModule().'-'.$this->_model->getLayoutName(),
            'size' => 3,
            'label-size' => 1,
        ));

        $dataMap = array(
            'module' => $this->_model->getModule(),
            'layout' => $this->_model->getLayoutName(),
            'placeholders' => $this->_model->getDataMap(),
        );
        $fields['placeholders'] = new User_Form_Element_UserDataMap('data_map', array(
            'label' => $this->_tlabel.'placeholders',
            'value' => $dataMap,
            'belongsTo' => $this->_belong_to,
        ));

        $this->addDisplayGroup( $fields, 'main', array(
            'legend' => $this->_tlabel.'group-std',
            'class' => 'no-bottom-space',
        ));

        $fields_buttons['submit'] = $this->createElement('submit', 'submit', array(
            'label' => 'cms_button_save',
            'class' => 'btn-lg'
        ));

        $this->addElements($fields_buttons);
    }

    protected function postIsValid($data)
    {
        $placeholders = array();

        $layout = explode('-', $this->getValue('layout'));
        array_shift($layout);
        $this->_model->setLayout(trim(join('-', $layout), '-'));

        $dm_value = $this->getValue('data_map');

        $dm_value['placeholders'] = isset($dm_value['placeholders']) ? $dm_value['placeholders'] : array();

        foreach($dm_value['placeholders'] as $k => $v){
            if(isset($v['widgets'])){
                foreach( $v['widgets'] as $vv){
                    $placeholders[$k]['widgets'][] = $vv;
                }
            }else{
                $placeholders[$k] = $v;
            }
        }

        $this->_model->setDataMapPlaceholders($placeholders);

        return parent::postIsValid($data);
    }
}