<?php

class User_Form_Admin_Emails extends Base_Form_Horizontal
{

    /**
     * @var User
     */
    protected $_model;

    public function init()
    {
        $fields = array();

        $optionsEmials = array();
        $mainEmail = null;
        foreach($this->_model->Emails as $email) { /** @var $email UserEmail */
            $optionsEmials[$email->email] = $email->email;
            if($email->is_main){ $mainEmail = $email->email;}
        }


        $fields['main_emial'] = new User_Form_Element_UserEmails('main_emial', array(
            'label' => $this->_tlabel.'main',
            'multiOptions' => $optionsEmials,
            'value' => $mainEmail,
            'label_class' => 'pull-left',
            'size' => 9, 'label-size' => 3,
            'class' => 'iCheck'
        ));

        $fields['submit'] = $this->createElement('submit', 'submit', array(
            'label' => 'cms_button_save',
            'offset' => 3,
            'size' => 9,
        ));


        $this->addDisplayGroup($fields, 'main', array(
            'legend' => $this->_tlabel.'group_info',
            'class' => 'panel-primary'
        ));
    }

    public function postIsValid($data)
    {
        $email = $this->getValue('main_emial');
        if(isset($this->_model->Emails[$email]) && $this->_model->Emails[$email]->is_active){
            Doctrine_Query::create()
                ->update('UserEmail')
                ->set('is_main', '0')
                ->where('id_user = ?', $this->_model->getId())
                ->execute();

            Doctrine_Query::create()
                ->update('UserEmail')
                ->set('is_main', '1')
                ->where('email = ?', $email)
                ->execute();
//            $this->_model->Emails[$email]->is_main = true;
//            $this->_model->Emails[$email]->save();
        }

        return true;
    }

}