<?php
/**
 * Created by JetBrains PhpStorm.
 * User: skotar
 * Date: 08.09.2013
 * Time: 12:09
 * To change this template use File | Settings | File Templates.
 */

class User_Form_Admin_Filter extends Base_Form_Vertical{

    /**
     * @var bool
     */
    protected $_filter = true;

    public function init()
    {
        $this->setMethod('get');
        $this->setAction('?page=1');
        $fields = array();
        $buttons = array();

        $fields['search'] = $this->createElement('text', 'search', array(
            'label' => $this->_tlabel.'name',
        ));

        $fields['email'] = $this->createElement('text', 'email', array(
            'label' => $this->_tlabel.'email',
        ));

        $options = array(
            '' => '',
            '0' => 'label-filter_archive_all',
            '1' => 'label-filter_archive_yes',
        );
        $fields['is_active'] = $this->createElement('select', 'archived_at', array(
            'label' => $this->_tlabel.'archived_at',
            'multiOptions' => $options,
        ));

        $fields['created_at_from'] = $this->createElement('DateTimePicker', 'created_at_from', array(
            'label' => $this->_tlabel.'created_at_from',
            'allowEmpty' => true,
            'required' => false,
            'datetime' => array(
                'format' => 'YYYY-MM-DD 00:00',
                'language' => 'pl',
            )
        ));

        $fields['created_at_to'] = $this->createElement('DateTimePicker', 'created_at_to', array(
            'label' => $this->_tlabel.'created_at_to',
            'allowEmpty' => true,
            'required' => false,
            'datetime' => array(
                'format' => 'YYYY-MM-DD 23:59',
                'language' => 'pl',
            )
        ));

        $buttons['clear'] = $this->createElement('clear', 'clear', array(
            'label' => 'cms_button_clear',
            'ignore' => true,
        ));


        $buttons['submit'] = $this->createElement('submit', 'submit', array(
            'label' => 'cms_button_search',
            'type' => 'submit',
            'class' => 'btn-info',
            'ignore' => true,
        ));

        $buttons['clear']->removeDecorator('WrapElement');
        $buttons['submit']->removeDecorator('WrapElement');

        $this->addDisplayGroup(array_merge($fields, $buttons), 'filter-search', array(
            'legend' => $this->_tlabel.'filter-search-form',
            'class' => 'panel-primary'
        ));

        $this->addHtmlTag(array($fields['search']), array('class' => 'col-md-4'));
        $this->addHtmlTag(array($fields['email']), array('class' => 'col-md-4'));
        $this->addHtmlTag(array($fields['is_active']), array('class' => 'col-md-4'));
        $this->addHtmlTag( array( $fields['created_at_from'] ), array('class' => 'col-md-4') );
        $this->addHtmlTag( array( $fields['created_at_to'] ), array('class' => 'col-md-4') );
        $this->addHtmlTag($buttons, array('class' => 'col-md-4 text-right', 'style' => 'margin-top: 25px;'));

        $this->addHtmlTag(array_merge($fields, $buttons), array('class' => 'row'));
    }

    public function populate(array $value)
    {
        if(!empty($value['created_at_from']) && !empty($value['created_at_to']))
        {
            if(strtotime($value['created_at_from']) > strtotime($value['created_at_to']))
            {
                $value['created_at_from'] = date('Y-m-d 23:59', strtotime($value['created_at_from']));
                $value['created_at_to'] = date('Y-m-d 00:00', strtotime($value['created_at_to']));
                $tmp = $value['created_at_to'];
                $value['created_at_to'] = $value['created_at_from'];
                $value['created_at_from'] = $tmp;
            }
        }

        return parent::populate($value);
    }
}