<?php
/**
 * Created by JetBrains PhpStorm.
 * User: Marek Skotarek
 * Date: 30.06.2013
 * Time: 01:30
 * To change this template use File | Settings | File Templates.
 */

class User_Form_ChangePass extends Base_Form_Horizontal {

    protected $_belong_to = "UserFormChangePass";

    protected $_tlabel = "user_form_change_pass_";

    /**
     * @var User
     */
    protected $_model;

    public function init()
    {
        $fields = array();

        // set validators
        $vStringLength = new Zend_Validate_StringLength(array('min' => 6, 'max' => 20));
        $vIdentical = new Zend_Validate_Identical('password');

        $fields['password'] = $this->createElement('password', 'password', array(
            'label' => $this->_tlabel.'password',
            'allowEmpty' => false,
            'required' => true,
            'filters' => array('StringTrim'),
            'validators' => array(
                array('NotEmpty', true),
                array($vStringLength, true)
            ),
        ));

        $fields['password_repeat'] = $this->createElement('password', 'password_repeat', array(
            'label' => $this->_tlabel.'password_repeat',
            'allowEmpty' => false,
            'required' => true,
            'filters' => array('StringTrim'),
            'validators' => array(
                array('NotEmpty', true),
                array($vStringLength, true),
                array($vIdentical, true)
            ),
        ));

        $fields['submit'] = $this->createElement('submit', 'submit', array(
            'label' => $this->_tlabel.'submit',
            'class' => 'pull-right'
        ));

        $this->addDisplayGroup(
            $fields,
            'main',
            array(
            )
        );

        $g = $this->getDisplayGroup('main');
        $g->removeDecorator('panel');
    }
}