<?php
/**
 * Created by JetBrains PhpStorm.
 * User: Marek Skotarek
 * Date: 11.07.2013
 * Time: 18:15
 * To change this template use File | Settings | File Templates.
 */

class User_Form_ManageEmails extends Base_Form_Horizontal {

    protected $_belong_to = "UserFormManageEmail";
    protected $_tlabel = "user_form_manage_email_";

    /**
     * @var UserEmail
     */
    private $_userEmails;

    public function init()
    {
        $fields = array();

        $this->_userEmails = Doctrine_Query::create()
            ->from('UserEmail ue INDEXBY ue.email')
            ->where('ue.id_user = ?', Base_Auth::getUser('id_user'))
            ->addWhere('ue.is_active = 1')
            ->execute();

        $options = array();
        $mainEmail = '';
        foreach ($this->_userEmails as $userEmail) { /** @var UserEmail $userEmail */
            $options[$userEmail->getEmail()] = $userEmail->getEmail();
            if($userEmail->is_main){ $mainEmail = $userEmail->getEmail(); }
        }

        $fields['email'] = $this->createElement('radio', 'email', array(
            'label' => $this->_tlabel.'is_main',
            'multiOptions' => $options,
            'validators' => array(
                array('InArray', true, array(array_keys($options))),
            ),
            'value' => $mainEmail,
            'size' => 9,
            'label-size' => 3
        ));

        $fields['submit'] = $this->createElement('submit', 'submit', array(
            'label' => $this->_tlabel.'submit',
            'size' => 9,
            'offset' => 3
        ));


        $this->addDisplayGroup(
            $fields,
            'main',
            array(
            )
        );

        $g = $this->getDisplayGroup('main');
        $g->removeDecorator('panel');

    }

    public function postIsValid($data)
    {
        Doctrine_Query::create()
            ->update('UserEmail')
            ->where('id_user = ?', Base_Auth::getUser('id_user'))
            ->set('is_main', '?', '0')
            ->execute();

        $emailValue = $this->getValue('email');
        $this->_userEmails[$emailValue]->is_main = true;
        $this->_userEmails[$emailValue]->save();

        return true;
    }

}