<?php

/**
 * User
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 * 
 * @package    ##PACKAGE##
 * @subpackage ##SUBPACKAGE##
 * @author     ##NAME## <##EMAIL##>
 * @version    SVN: $Id: Builder.php 7490 2010-03-29 19:53:27Z jwage $
 */
class User extends Table_User
{
    /**
     * @param array $options
     * @return Doctrine_Query
     */
    public static function getQuery($options = array())
    {
        $query = parent::getQuery($options);

        if(isset($options['mainEmail'])){
            $query->addSelect('e.email as email_main')
                ->innerJoin('o.Emails e WITH e.is_main = 1');
        } else {
            $query->innerJoin('o.Emails e');
        }

        if ( isset( $options['email'] ) && !empty( $options['email'] ) ) {
            $query->addWhere('e.email LIKE ?', '%' . $options['email'] . '%');
        }

        if ( isset( $options['created_at_from'] ) && !empty( $options['created_at_from'] ) ) {
            if ( $options['created_at_from'] < @$options['created_at_to']) $query->addWhere('o.created_at >= ?', $options['created_at_from']);
        }

        if ( isset( $options['created_at_to'] ) && !empty( $options['created_at_to'] ) ) {
            if ( @$options['created_at_from'] < $options['created_at_to']) $query->addWhere('o.created_at <= ?', $options['created_at_to']);
        }

        return $query;
    }

    /**
     * @return string
     */
    public function getUserName()
    {
        return trim($this->getName().' '.$this->getSurname());
    }

    /**
     * @return false|UserEmail
     */
    public function getMainEmail()
    {
        return UserEmail::findMainEmailByIdUser($this->getId());
    }

    public function getRoles()
    {
        return Base_Auth::getUserRoles($this->role);
    }

    /**
     * @param $value
     * @return $this
     */
    public function setPassword($value)
    {
        if(strlen($value) > 0 ){
            $this->password = Base_Auth::hashPassword($value);
        }
        return $this;
    }

    /**
     * @param $value
     * @param null $id_language
     * @return $this
     */
    public function setIdLanguage($value, $id_language = null)
    {
        $this->id_language = !empty($value) ? $id_language : null;

        return $this;
    }


    public function setIdProfileImage($value)
    {
        if(!empty($value)){
            $upload = new Zend_File_Transfer_Adapter_Http();
            $files = $upload->getFileInfo();
            if(isset($files['id_profile_image']) && $files['id_profile_image']['error'] == 0){
                $image = Image::createImage($this, array(
                    'type' => Base::getFileExt($upload->getFileName('id_profile_image', false)),
                    'name' => $upload->getFileName('id_profile_image', false),
                    'source' => $upload->getFileName('id_profile_image')
                ));

                if(!empty($this->id_profile_image)){
                    Base_EventManager::trigger('imageDelete', $this->getIdProfileImage());
                }

                $this->id_profile_image = $image->getId();
            }
        }

    }

    /**
     * @param $value
     * @return $this
     */
    public function setRole($value)
    {
        if(is_array($value)){
            $value = join(',',$value);
        }

        $this->role = $value;

        return $this;
    }

    public static function getListArray()
    {
        $result = self::getList();
        $listOptions = array();
        foreach ($result as $row) {
            $listOptions[$row['id_user']] = $row['name'] . ' ' . $row['surname'];
        }

        return $listOptions;
    }
}