<?php
$router = Zend_Controller_Front::getInstance()->getRouter();

$router->addRoute('user_admin', new Zend_Controller_Router_Route(
	'/@admin/@users',
	array(
		'module' => 'user',
		'controller' => 'admin',
		'action' => 'index',
	)
));

$router->addRoute('user_admin_new', new Zend_Controller_Router_Route(
    '/@admin/@user/@new',
    array(
        'module' => 'user',
        'controller' => 'admin',
        'action' => 'new',
    )
));

$router->addRoute('user_admin_edit', new Zend_Controller_Router_Route(
    '/@admin/@user/@edit/:id_user',
    array(
        'module' => 'user',
        'controller' => 'admin',
        'action' => 'edit',
    ),
    array(
        'id_user' => '\d+'
    )
));

$router->addRoute('user_admin_delete', new Zend_Controller_Router_Route(
    '/@admin/@user/@delete/:id_user',
    array(
        'module' => 'user',
        'controller' => 'admin',
        'action' => 'delete',
    ),
    array(
        'id_user' => '\d+'
    )
));

$router->addRoute('user_admin_delete-email', new Zend_Controller_Router_Route(
    '/@admin/@user/@delete-email/:email',
    array(
        'module' => 'user',
        'controller' => 'admin',
        'action' => 'delete-email',
    ),
    array(
        'email' => '.*'
    )
));

$router->addRoute('user_admin_archive', new Zend_Controller_Router_Route(
    '/@admin/@user/@archive/:id_user',
    array(
        'module' => 'user',
        'controller' => 'admin',
        'action' => 'archive'
    ),
    array(
        'id_user' => '\d+'
    )
));

$router->addRoute('user_admin_unarchive', new Zend_Controller_Router_Route(
    '/@admin/@user/@unarchive/:id_user',
    array(
        'module' => 'user',
        'controller' => 'admin',
        'action' => 'unarchive'
    ),
    array(
        'id_user' => '\d+'
    )
));

Zend_Controller_Front::getInstance()->setRouter($router);


