<?php
/**
 * Created by JetBrains PhpStorm.
 * User: Robert
 * Date: 17.06.2014
 * Time: 16:34
 * To change this template use File | Settings | File Templates.
 */

class User_Widget_CmsDashboard_StatsUsers extends Base_Widget_Abstract
{
    public $name = 'label_user_widget_cms_dashboard_stats_users';

    public function getViewScriptsDir()
    {
        return dirname(__DIR__);
    }

    public function getRenderView()
    {
        return 'cms-dashboard/stats-users.phtml';
    }

    public function renderWidget()
    {
        $this->view->statsCountUsers = Doctrine_Query::create()
            ->select('count(*) as count')
            ->from('User u')
            ->where('u.archived_at IS NULL')
            ->fetchOne()
            ->count;

        $zDate = new Zend_Date();
        $zDate->subDay(7)->setTime(0);
        $this->view->statsCountWeekUsers = Doctrine_Query::create()
            ->select('count(*) as count')
            ->from('User u')
            ->where('u.archived_at IS NULL')
            ->addWhere('u.created_at >= ?', $zDate->toString('YYYY-MM-dd HH:mm:ss'))
            ->fetchOne()
            ->count;

        $this->view->statsCountOnlineUser = Doctrine_Query::create()
            ->select('count(*) as count')
            ->from('Session s')
            ->where('s.modified >= (? - '.Session::$time_online_sec.')', time())
            ->fetchOne()
            ->count;

        $zDate->setTimestamp(time());
        $minDate = new Zend_Date();
        $minDate->subMonth(6);
        $statsUsersRegister = array();
        $i=0;

        do{
            $statsUsersRegister[] = array($zDate->toString('YYYY-MM-dd'), rand(0, 100));
            $zDate->subDay(1);
            if($i++>1000) break;
        }while($zDate->isLater($minDate));

        $statsUsersRegister = array_reverse($statsUsersRegister);
        $this->view->statsUsersRegister = $statsUsersRegister;
    }
}