<?php
/**
 * Created by PhpStorm.
 * User: Robert Rogiński
 * Date: 08.05.14
 * Time: 10:18
 */
class Base_Form_Decorator_InputGroup extends Zend_Form_Decorator_Abstract
{
    /**
     * Renders a form element decorating it with the Twitter's Bootstrap markup
     *
     * @param $content
     *
     * @return string
     */

    public function render($content)
    {
        $input_group = $this->getElement()->getAttrib('input-group');
        $attribs = $this->getOptions();

        if(!empty($input_group))
        {
            if(isset($input_group['pre']) && !empty($input_group['pre'])){
                $content = $this->_getHtmlInputGroup($input_group['pre']) . $content;
            }

            if(isset($input_group['post']) && !empty($input_group['post'])){
                $content = $content . $this->_getHtmlInputGroup($input_group['post']);
            }

            $class = trim($attribs['class'].' '.@$input_group['class']);
            $content = '<div class="'.$class.'">'.$content.'</div>';
        }
        return $content;
    }

    private function _getHtmlInputGroup($data)
    {
        $html = '';
        $view = $this->getElement()->getView();

        if(is_array($data))
        {
            $type  = isset($data['type'])  ? $data['type'] : 'text';
            $label = isset($data['label']) ? $data['label'] : '';
            $class = isset($data['class']) ? $data['class'] : 'btn-default';
        }
        else
        {
            $type  = 'text';
            $label = $data;
            $class = isset($data['class']) ? $data['class'] : 'btn-default';
        }

        if($type == 'text')
        {
            $addon_class = 'input-group-addon';
            $html = '<span class="'.$addon_class.'">'.$label.'</span>';
        }
        elseif($type == 'button')
        {
            $addon_class = 'input-group-btn';
            $html = '<span class="'.$addon_class.'">
                            <button class="btn '.$class.'" type="button">
                                '. $label .'
                            </button>
                         </span>';
        }
        elseif($type == 'shere_point')
        {
            $addon_class = 'input-group-btn';
            $href = isset($data['href']) ? $data['href'] : Base::url('admin_cms-shere-elements');
            $fancybox_type = isset($data['fancybox-type']) ? $data['fancybox-type'] : 'iframe';

            $html = '<span class="'.$addon_class.'">
                        <a data-fancybox-type="'.$fancybox_type.'" href="'.$href.'" class="btn '.$class.' initSherePointField">
                                '. $label .'
                        </a>
                     </span>';

            $view->headScript()->appendFile('/assets/js/sherePoint.js');
            $view->headLink()->appendStylesheet('/assets/lib/fancybox/source/jquery.fancybox.css');
            $view->headScript()->appendFile('/assets/lib/fancybox/source/jquery.fancybox.js');
        }

        return $html;
    }


}
