<?php
/**
 * Created by JetBrains PhpStorm.
 * User: skotar
 * Date: 23.08.2013
 * Time: 18:15
 * To change this template use File | Settings | File Templates.
 */

class Base_View_Helper_FormDateTimePicker extends Zend_View_Helper_FormElement {

    public function formDateTimePicker($name, $value=null, $attribs=null)
    {
        $info = $this->_getInfo($name, $value, $attribs);
        extract($info); // name, value, attribs, options, listsep, disable

        // build the element
        $disabled = '';
        if ($disable) {
            // disabled
            $disabled = ' disabled="disabled"';
        }

        $attribs['class'] = trim(@$attribs['class']);


        // end tag depend of doctype
        $endTag = ' />';

        if ( ($this->view instanceof Zend_View_Abstract) &&  !$this->_isXhtml()) {
            $endTag = '>';
        }

        $addon_icon = isset($attribs['addon-icon']) && strlen($attribs['addon-icon']) > 0 ? $attribs['addon-icon'] : 'calendar';

        $xhtml = '
        <div class="input-group date form_time '.$this->view->escape($id).'">
            <input type="text" id="'.$this->view->escape($id).'" name="'.$this->view->escape($name).'" value="'.$this->view->escape($value).'" ' . $disabled . $this->_htmlAttribs($attribs) . $endTag
        .' <span class="input-group-addon"><span class="glyphicon glyphicon-' . $addon_icon . '"></span></span>
        </div>';

        $datetime = false;
        if ( array_key_exists('datetime', $attribs) ) {
            $datetime = true;
            $datetime_option = json_encode((array) $attribs['datetime']);
            unset($attribs['datetime']);
        }

        if ( $datetime ) {
            $this->view->headScript()->appendScript("$('.".$this->view->escape($id)."').datetimepicker(".$datetime_option.")");
        }
        else
        {
            $this->view->headScript()->captureStart();
            echo "
                $('.".$this->view->escape($id)."').datetimepicker(
                    {
                        format: 'YYYY-MM-DD HH:mm',
                        language: 'pl',
                    }
                );
            ";
            $this->view->headScript()->captureEnd();
        }

//        $this->view->headScript()->captureStart();
//        echo "
//            $('.dateTimePickerBootstrap').datetimepicker(
//                {
//                    format: 'YYYY-MM-DD',
//                    language: 'pl',
//                }
//            );
//        ";
//
//        $this->view->headScript()->captureEnd();

        return $xhtml;
    }
}