$(function() {

    var map;
    var markersArray = [];
    var geocoder;

    initMap();

    function initMap()
    {
        geocoder = new google.maps.Geocoder();

        // aktualne pozycje
        var latStr = $('input.lat').val();
        var lngStr = $('input.lng').val();
        var geo = true;

        var lat = 52.23;
        var lng = 21.011;

        if(latStr !== '' && lngStr !== '') {
            geo = false;
            lat = parseFloat(latStr);
            lng = parseFloat(lngStr);
        }

        var latlng = new google.maps.LatLng(lat, lng);
        var myOptions = {
            scrollwheel: false,
            zoom: 10,
            center: latlng,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        };
        map = new google.maps.Map(document.getElementById("map-canvas"), myOptions);
        google.maps.event.addListener(map, "click", function(event)
        {
            placeMarker(event.latLng);

            $('input.lat').val(event.latLng.lat());
            $('input.lng').val(event.latLng.lng());
        });

        if(false == geo) {
            placeMarker(latlng);
        } else {
            // geolokalizacja
            var address = [];
            address[address.length] = $('.address_street').val();
            address[address.length] = $('.address_city').val();

            geocoder.geocode( { 'address': address.join(', ') }, function(results, status) {
                if (status == google.maps.GeocoderStatus.OK) {
                    var location = results[0].geometry.location;
                    placeMarker(location);
                    map.setCenter(location);
                    $('input.lat').val(location.lat());
                    $('input.lng').val(location.lng());
                } else {
                    placeMarker(latlng);
                    $('input.lat').val(latlng.lat());
                    $('input.lng').val(latlng.lng());
//                    alert("Geocode was not successful for the following reason: " + status);
                }
            });
        }
    }

    function placeMarker(location) {
        deleteOverlays();
        var marker = new google.maps.Marker({
            position: location,
            map: map
        });
        markersArray.push(marker);
    }

    function deleteOverlays() {
        if (markersArray) {
            for (i in markersArray) {
                markersArray[i].setMap(null);
            }
            markersArray.length = 0;
        }
    }
});