$(function() {
    $('body').on('change', '.addressAjax', autocompleteData);
    $('body').on('clear', '.addressAjax', function() {
        var nextSelector = $($(this).data('address-selector'));
        var placeholder = $(this).attr('placeholder');

        if($(this).is("select")){
            $('option', $(this)).remove();
            $(this).append('<option label="" value=""></option>');

            $(this).select2({
                allowClear: true,
                placeholder: placeholder
            });
        }
        else{
            $(this).val('');
        }

        if ( $(this).hasClass('addressTrigger') ) {
            nextSelector.trigger("clear");
        }
    });
});

var autocompleteData = function() {
    var me = $(this);
    var nextSelectorClass = me.data('address-selector');
    var nextSelector = $(nextSelectorClass);
    var preloaderMsg = $(this).parents('.addressForm').data('preloader-msg');

    var requestData = {q: me.val()};
    parentSelector = $(me.data('address-selector-parent'));

    while(parentSelector.length > 0){
        requestData[parentSelector.data('name')] = parentSelector.val();
        parentSelector = $(parentSelector.data('address-selector-parent'));
    }


    $.ajax({
        url: me.data('url')
        ,dataType: 'json'
        ,data: requestData
        ,beforeSend: function() {
            $('<span data-preloader="'+me.data('address-selector')+'"><i class="fa fa-spin fa-spinner" style="font-size: 16px; margin-top: 7px;"></i> '+preloaderMsg+'</span>').insertAfter('[data-address-selector="'+me.data('address-selector')+'"]');
        }
        ,complete: function() {
            $('span[data-preloader="'+me.data('address-selector')+'"]').remove();
        }
        ,success: function(response) {
            nextSelector.trigger("clear" + "");

            if(nextSelector.is("select")){
                var placeholder = nextSelector.attr('placeholder');

                $.each(response.list, function(i, v) {
                    nextSelector.append('<option label="'+ v +'" value="'+ i +'">'+v+'</option>');
                });
                nextSelector.select2(
                    {
                        allowClear: true,
                        placeholder: placeholder
                    }
                );
            }

        }
    });
};