$(document).ready(function(){
    $('body').on('click', ".confirmModal", confirmModal);
    $('body').on('click', ".deleteWidget", deleteWidget);
    $('body').on('click', ".button-search", searchFilter);

    $('[data-mouseover]').mouseover( function(){ $(this).addClass($(this).data('mouseover')); });
    $('[data-mouseover]').mouseout( function(){$(this).removeClass($(this).data('mouseover')); });

    $('body').on('loaded', 'input[type=checkbox].iCheck', init_iCheckCheckbox);
    $('body').on('loaded', 'input[type=radio].iCheck', init_iCheckRadio);
    $('input[type=checkbox].iCheck').trigger('loaded');
    $('input[type=radio].iCheck').trigger('loaded');
    initLoaded.addFn(init_iCheckCheckbox);
    initLoaded.addFn(init_iCheckRadio);

    // overbox
    if(typeof $(this).overbox == 'function'){
        $('.overbox').overbox();
    }

    $('body').on('loaded', 'form', submitSendingButton);
    $('form').trigger('loaded');

    initLoaded.addEl('form');

});

var clockId;

function clock(){
    var data = new Date();
    var hour = data.getHours();
    var minutes = data.getMinutes();
    var clock_separation = document.getElementById('clock_separation');

    if(document.getElementById('clock_hour') && document.getElementById('clock_minutes')){
        document.getElementById('clock_hour').innerHTML = (hour < 10) ? "0"+hour : hour;
        document.getElementById('clock_minutes').innerHTML = (minutes < 10) ? "0"+minutes : minutes;
    }
    //clock_separation.innerHTML = clock_separation.innerHTML == ":" ? "" : ":";
}

clockId=setInterval("clock()",10000);


var init_iCheckCheckbox = function()
{
    if($(document).iCheck){
        $(this).iCheck({checkboxClass: 'icheckbox_minimal-blue'});
    }
    //if ($().iCheck) {
    //    $('input[type=checkbox].iCheck').iCheck({checkboxClass: 'icheckbox_minimal-blue'});
    //}
}

var init_iCheckRadio = function()
{
    if($(document).iCheck){
        $(this).iCheck({radioClass: 'iradio_minimal-blue'});
    }
    //if ($().iCheck){
    //    $('input[type=radio].iCheck').iCheck({radioClass: 'iradio_minimal-blue'});
    //}
}


var _el_tmp;

var deleteWidget = function (){
    $('#confirmModal').modal('hide');
    var gritter_title = _el_tmp.data('gritter-title');
    var gritter_text = _el_tmp.data('gritter-text');
    if(gritter_title && gritter_text){
        $.gritter.add({ title: gritter_title, text:	gritter_text });
    }

    _el_tmp.parent().parent().remove();

    return false;
}

var confirmModal = function(){
    var confirmModal = $('#confirmModal');
    var a = confirmModal.find('.modal-footer a');
    _el_tmp = $(this);
    var label = _el_tmp.data('label');
    var title = _el_tmp.data('title');
    var text = _el_tmp.data('text');
    var href = _el_tmp.attr('href');
    var ajax = _el_tmp.data('ajax');
    var cl = _el_tmp.data('class');

    if(label != undefined){ confirmModal.find('#myModalLabel').html(label); }
    if(title != undefined){ confirmModal.find('.modal-body h4').html(title); }
    if(text != undefined){ confirmModal.find('.modal-body p').html(text); }
    if(href != undefined){ a.attr('href', href); }
    if(cl != undefined){ a.addClass(cl); }

    var gritter_title = _el_tmp.data('gritter-title');
    var gritter_text = _el_tmp.data('gritter-text');
    if(gritter_title && gritter_text){
        a.attr('data-gritter-title', gritter_title);
        a.attr('data-gritter-text', gritter_text);
    }

    if(ajax != undefined){
        a.addClass('ajax');
        a.attr('data-dismiss', 'modal');
        var data_remove = $(this).data('ajax-remove');
        if(data_remove){ a.attr('data-remove', data_remove); }
    }
    confirmModal.modal();

    return false;
}

// Loader on submit button
var submitSendingButton = function()
{
    var form = $(this);
    form.submit(function ()
    {
        var btn = $(this).find(".submit[data-sending-message]");

        // use attribute 'loader' to disable set loader on this button
        var loader = btn.attr('loader');
        if(loader == 'false'){
            return true;
        }

        if(btn.length > 0)
        {
            var ask = true;
            if(btn.hasClass("mass-edit-button") == true) {
                ask = confirm(btn.data('confirm'));
            }

            if(ask == true)
            {
                btn.attr('disabled', true);
                var getClass = btn.attr('class');
                var getId = btn.attr('id');
                var getDataSendingMessage = btn.data('sending-message');

                btn.replaceWith("<button id='" + getId + "' class='" + getClass + "' type='submit' disabled='disabled'>" +
                "<i class='fa fa-spinner fa-spin'></i> " +
                getDataSendingMessage +
                "</button>");
            }
            else{
                return false;
            }
        }
    });
}


// Mass action
var _prefix = '#Admin_Form_MassAction';
var _row = [];

$('input[type=checkbox].selectAll').on( 'ifChecked', function() {
    $('.selectOne').iCheck('check');
} );

$('input[type=checkbox].selectAll').on( 'ifUnchecked', function() {
    $('.selectOne').iCheck('uncheck');
} );


$('input[type=checkbox].selectOne').on( 'ifChecked', function() {

    // take value from checkboxes
    // find a form
    // show a mass form
    // add hidden input to form to send a value

    var value = $(this).val(),
        name = 'selected_checkbox[]',
        id = 'selected_checkbox_'+value,
        form = $(_prefix + ' form');

    _row.push(id);

    $(_prefix).massAction('show');

    $(form).prepend(
        $('<input type="hidden" value="'+value+'" name="'+name+'" id="'+id+'" />')
    );

} );

$('input[type=checkbox].selectOne').on( 'ifUnchecked', function() {

    // take value from input
    // take good id
    // delete input hidden witch taken value
    // delete elem from array "row"
    // if array is empty than hide a form

    var value = $(this).val(),
        id = '#selected_checkbox_'+value;

    $(id).remove();
    _row.splice(_row.indexOf(id), 1)

    if ( 0 == _row.length ) {
        $(_prefix).massAction('hide');
    }

} );

// fn mass action
$.fn.massAction = function (action) {

    if ( 'show' == action ) {
        var returnn = $(this).show();
    }

    if ( 'hide' == action ) {
        var returnn = $(this).hide();
    }

    return returnn;
};

var searchFilter = function(){
    var display = $('.filter-search').css('display');
    var icon = $(this).find('.search-direction');
    if(display == 'block'){
        $('.filter-search').css('display', 'none');
        icon.removeClass('glyphicon-chevron-up');
        icon.addClass('glyphicon-chevron-down');
    }else{
        $('.filter-search').css('display', 'block');
        icon.removeClass('glyphicon-chevron-down');
        icon.addClass('glyphicon-chevron-up');
    }
}


/**
* Object reinitialize elements after content is load by ajax
*
* @type {{elements: Array, fn: Array, triggerName: string, addEl: Function, addFn: Function, init: Function, initEl: Function, initFunc: Function}}
*/
var initLoaded = {
    elements: []
    ,fn: []
    ,triggerName: 'loaded'

    ,addEl: function(item) {
        this.elements.push(item);
    }

    ,addFn: function(item) {
        this.fn.push(item);
    }

    ,init: function(loadEl){
        $(loadEl).trigger('loaded');
        this.initEl(loadEl);
        this.initFunc(loadEl);
    }

    ,initEl: function(loadEl) {
        var self = this;

        $.each(this.elements, function( index, value ) {
            $(loadEl).find(value).trigger(self.triggerName);
        });
    }

    ,initFunc: function(loadEl){
        $.each(this.fn, function( index, fn ) {
            fn(loadEl);
        });
    }
}




