/**
 * @var addDomain
 * Use 'data-tinymce-domain' in wysiwyg form to add domain before uri address
 */
var addDomain = '';

var myCustomFileBrowser = function(field_name, url, type, win)
{
    var myHref = '/admin/cms-shere-elements';

    if(type == 'image'){
        myHref = '/admin/filemanager/getImage';
    }

    $.fancybox.open(
        {
            maxWidth: '85%',
            fitToView: false,
            width: '80%',
            height: '80%',
            autoSize: false,
            closeClick: false,
            openEffect: 'none',
            closeEffect: 'none',
            type: 'iframe',
            href: myHref,
            helpers:  {
                overlay : null
            },
            wrapCSS: 'tinymce-fancybox-wrap'
        }
    );
    insertSherePointItem = function (data) {
        var uri = data.uri;
        uri = addDomain + uri;

        $('input#' + field_name, win.document).val(uri);
    }
}

var tiny_options = {
    script_url:'/assets/lib/tinymce/tinymce.min.js'
    ,convert_urls: false
    ,height : 300
    ,image_advtab: false
    ,menubar: "edit insert view tools format table"
    ,language: 'pl'
    ,document_base_url: window.location.protocol + '//' + window.location.hostname
    ,plugins: [
        "advlist autolink link image lists charmap hr anchor pagebreak",
        "searchreplace visualblocks visualchars code insertdatetime nonbreaking",
        "save table contextmenu directionality paste textcolor"
    ]
    ,toolbar: "undo redo | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image forecolor"
    ,file_browser_callback: myCustomFileBrowser
    ,style_formats: [
        {title: "Headers", items: [
            {title: "Header 1", format: "h1"},
            {title: "Header 2", format: "h2"},
            {title: "Header 3", format: "h3"},
            {title: "Header 4", format: "h4"},
            {title: "Header 5", format: "h5"},
            {title: "Header 6", format: "h6"}
        ]},
        {title: "Inline", items: [
            {title: "Bold", icon: "bold", format: "bold"},
            {title: "Italic", icon: "italic", format: "italic"},
            {title: "Underline", icon: "underline", format: "underline"},
            {title: "Strikethrough", icon: "strikethrough", format: "strikethrough"},
            {title: "Superscript", icon: "superscript", format: "superscript"},
            {title: "Subscript", icon: "subscript", format: "subscript"},
            {title: "Code", icon: "code", format: "code"}
        ]},
        {title: "Blocks", items: [
            {title: "Paragraph", format: "p"},
            {title: "Blockquote", format: "blockquote"},
            {title: "Div", format: "div"},
            {title: "Pre", format: "pre"}
        ]},
        {title: "Alignment", items: [
            {title: "Left", icon: "alignleft", format: "alignleft"},
            {title: "Center", icon: "aligncenter", format: "aligncenter"},
            {title: "Right", icon: "alignright", format: "alignright"},
            {title: "Justify", icon: "alignjustify", format: "alignjustify"}
        ]},
        {title: "Image", items: [
            {title: "Image Responsive", selector: 'img', styles: { 'width': '100%', 'height': 'auto' }},
            {title: "Image Left", selector: 'img', styles: { 'float': 'left', 'margin': '0 10px 10px 0' }},
            {title: "Image Right", selector: 'img', styles: { 'float': 'right', 'margin': '0 0 10px 10px' }}
        ]}
    ]
};

var tiny_options_small = {
    script_url:'/assets/lib/tinymce/tinymce.min.js'
    ,convert_urls: false
    ,height : 200
    ,image_advtab: false
    ,menubar: ""
    ,language: 'pl'
    ,plugins: [
        "advlist autolink link image lists charmap hr anchor pagebreak",
        "searchreplace visualblocks visualchars code insertdatetime nonbreaking",
        "save table contextmenu directionality paste textcolor"
    ]
    ,toolbar: "undo redo |  bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent"
    ,file_browser_callback: myCustomFileBrowser
    ,style_formats: []
};

var tiny = function () {
    if($('textarea').data('small') == true) {
        var opt = tiny_options_small;
    } else {
        var opt = tiny_options;
    }

    if($("textarea").data('tinymce-domain') && $('textarea').data('tinymce-domain').length > 0) {
        addDomain = $('textarea').data('tinymce-domain');
    }

    if ($(this).hasClass('tinyON') == false) {
        $(this).addClass('tinyON');
        if ( typeof tinyMCE != 'undefined') {
            removeTiny;
        }

        $(this).tinymce(opt);
    }
}

var removeTiny = function (textarea) {
    if (textarea == undefined) return false;
    if($(textarea).hasClass('tinyON')){
        $(textarea).removeClass('tinyON');
        textarea.tinymce().remove();
    }
}

var triggerLoadedTiny = function(t){
    setTimeout(function () {
        $(t).find('textarea[aria-role="tinymce"]').trigger('loaded');
    }, 1);
}

$(document).ready(function () {
    $('body').on('loaded', 'textarea[aria-role="tinymce"]', tiny);
    $('textarea[aria-role="tinymce"]').trigger('loaded');
    initLoaded.addFn(triggerLoadedTiny);
});