function onLoadIframe()
{
    $('.overbox-iframe-loading').remove();
}

(function($) {
    $.fn.overbox= function(options, fire) {

        options = $.extend({
            buttonCloseText: 'Zamknij'
            ,buttonConfirmText: 'Tak, potwierdzam'
            ,buttonConfirmClass: 'btn btn-danger'
            ,textClose: 'Zamknij'
            ,displayHeader: true
            ,displayBody: true
            ,displayFooter: true
        }, options);


        var contener = $();
        var contenerWrap = $();
        var contenerHeader = $();
        var contenerBody = $();
        var contenerFooter = $();

        var type = 'inline';

        return this.each(function() {
            var self = $(this);

            self.on('click', function (event) {
                shoxBox();
                return false;
            });


            var shoxBox = function(){
                self.trigger('overbox.show');

                var title = self.data('overbox-title');

                if(self.data('overbox-type')){ type = self.data('overbox-type'); }

                var displayHeader = options.displayHeader;
                var displayBody = options.displayBody;
                var displayFooter = options.displayFooter;
                var buttonConfirmClass = options.buttonConfirmClass;
                var href = self.attr('href');
                var height = self.data('overbox-height');
                var wrapContenerStyle = self.data('overbox-wrap-style');



                if(displayBody){
                    var content = self.data('overbox-content');
                    if(content && content.length > 0){ content = $('#'+content); }

                    if(content && content.length > 0){
                        contenerBody = $(content.html());
                    }else if(self.data('overbox-text')){
                        contenerBody = $(self.data('overbox-text'));
                    }
                }

                if(self.data('overbox-button-confirm-class')){
                    buttonConfirmClass = self.data('overbox-button-confirm-class');
                }


                if(displayHeader && (!title || title.length == 0)){
                    displayHeader = false;
                }

                if(displayFooter && self.data('overbox-display-footer') === 0){
                    displayFooter = false;
                }

                if(displayFooter){
                    var contentTmp = self.data('overbox-content-footer');
                    if(contentTmp && contentTmp.length > 0){ contentTmp = $('#'+contentTmp); }

                    if(contentTmp && contentTmp.length > 0){
                        contenerFooter = $(contentTmp.prop('innerHTML'));
                    }
                }



                /**
                 * main contener
                 */
                contener = $('<div class="overbox-contener"></div>');
                contener.append($('<div class="overbox-back" data-dismiss="overbox"></div>'));

                contenerWrap = $('<div class="overbox-wrap" style="'+wrapContenerStyle+'">');
                contener.append(contenerWrap);


                /**
                 * header content
                 */
                if(displayHeader){
                    contenerHeader = $('\
                        <div class="overbox-header">\
                            <button type="button" class="close" data-dismiss="overbox" aria-label="Close"><i class="fa fa-close"></i></button>\
                            <h1 class="page-title">'+title+'</h1>\
                        </div>\
                    ');
                }


                /**
                 *  body content
                 */
                if(displayBody){
                    if(type == 'inline'){
                        contenerBody = $('<div class="overbox-body"></div>').append(contenerBody);
                    }else if(type == 'iframe'){
                        contenerBody = $('<div class="overbox-body">\
                            <div class="overbox-loading" style="height:'+height+'"><i class="fa fa-spinner fa-spin"></i> wczytuję...</div>\
                            <iframe frameborder="0" src="'+insertParam(href, 'iframe', '1')+'" scrolling="auto" style="width: 100%;" height="'+height+'" onload="onLoadIframe()"></iframe>\
                        </div>');
                    }else if(type == 'ajax'){

                        contenerBody = $('\
                            <div class="overbox-body">\
                                <div class="overbox-loading" style="height:'+height+'">\
                                    <i class="fa fa-spinner fa-spin"></i> wczytuję...\
                                </div>\
                            </div>');


                        $.ajax({
                            url: href,
                            success : function(responseTxt) {
                                responseContenerBody = $(responseTxt);

                                if($(responseContenerBody[0]).attr('class') == 'overbox-body'){
                                    contenerBody = $(responseContenerBody[0]);
                                }else{
                                    contenerBody.html(responseContenerBody);
                                }

                                if($(responseContenerBody[2]).attr('class') == 'overbox-footer'){
                                    contenerFooter = $(responseContenerBody[2]);
                                }

                                createOverBox();
                            },
                        });
                    }
                }



                /**
                 * footer content
                 */
                if(displayFooter){
                    if(!contenerFooter.html()){
                        contenerFooter = $('\
                            <button aria-hidden="true" data-dismiss="overbox" class="btn btn-link">'+options.buttonCloseText+'</button>\
                            <a class="'+buttonConfirmClass+'" data-dismiss="overbox" href="'+href+'">'+options.buttonConfirmText+'</a>\
                        ');
                    }

                    contenerFooter = $('<div class="overbox-footer"></div>').append(contenerFooter);
                }



                createOverBox();

            }



            function createOverBox()
            {
                contenerWrap.empty();
                contenerWrap.append(contenerHeader);
                contenerWrap.append(contenerBody);
                contenerWrap.append(contenerFooter);

                /**
                 * display overbox
                 */
                contener.on('click', '[data-dismiss="overbox"]', closeBox);
                self.trigger('overbox.shown', [contener]);

                $('body').append(contener);

                contener.trigger('overbox.ready');
                contener.trigger('loaded');
            }



            var closeBox = function(){
                self.trigger('overbox.hide');
                $(this).closest('.overbox-contener').remove();
                self.trigger('overbox.hidden');
            }


            function insertParam(uri,key,value)
            {
                key = encodeURIComponent(key); value = encodeURIComponent(value);
                var separator = uri.indexOf('?') !== -1 ? "&" : "?";

                return uri + separator + key + "=" + value;
            }

        });


    };


})(jQuery);

$('body').on('overbox.ready', '.overbox-contener', function(){
    $(this).find('.overbox').overbox();
});

